
      subroutine comp_micr(xr, xf,xs, ishp)
      implicit none
      integer i, is(2), ishp
      double precision xr(3), xf(3), xs(3),phi1,phi2,gam1,gam2
      double precision tol, xnorm, angle,ang1,ang2,xphi1,xphi2,xm
c
c...  geometrical parameters for cylinder
      double precision r_out, r_in, xh

c...  geometrical parameters for ellipsoids  
      double precision phi(2), xphi, xrad,pi
      double precision alp(2), rad(2), grad(2,2)
      double precision a(4),b(4),c(4),res(2), cthe,sthe,norms
      double precision phimax(4), zth(2) 
 
c...  select the geometry of the problem 
c     ishp = 1             ! =1 : cylinder,  =2: ellipsoid, =3 :plate
c     
      if (ishp.eq.1) then       ! CYLINDER 
c
      r_in  = 18.d0             ! inner radius 
      r_out = 30.d0             ! outer radius 
      xh    = 60.d0             ! height 
c
      xrad   = dsqrt(xr(1)*xr(1) + xr(2)*xr(2))
      cthe   = xr(1)/xrad
      sthe   = xr(2)/xrad
      phi(1) =  datan(1.d0)*4.d0*80.d0/180.d0
      phi(2) = -datan(1.d0)*4.d0*80.d0/180.d0
      xphi = phi(1) + (phi(2)-phi(1))*(xrad-r_in)/(r_out-r_in)
c
      xf(1) =  sthe * dcos(xphi)
      xf(2) = -cthe * dcos(xphi)
      xf(3) =        -dsin(xphi)
c   
c      write(*,*) (xf(i), i=1,3)
c
      xs(1) = -cthe 
      xs(2) = -sthe 
      xs(3) =  0.d0 
c     
      elseif (ishp.eq.2) then    ! ELLIPSOIDS 
c...  COMPUTE THE FIBER DIRECTION AT THAT POINT 
c...  phi_1: LV_in, phi_2: LV_out, phi_3: RV_in, phi_3: RV_out   


!      a(1) = 18.d0              ! LV_in
!      b(1) = 18.d0              ! LV_in
!      c(1) = 58.d0              ! LV_in
!      a(2) = 30.d0              ! LV_out
!      b(2) = 30.d0              ! LV_out
!      c(2) = 70.d0              ! LV_out
!      a(3) = 24.d0              ! RV_in
!      b(3) = 45.d0              ! RV_in
!      c(3) = 54.d0              ! RV_in
!      a(4) = 30.d0              ! RV_out
!      b(4) = 51.d0              ! RV_out
!      c(4) = 60.d0              ! RV_out
      
!      a(1) = 30.d0              ! LV_in
!      b(1) = 33.d0              ! LV_in
!      c(1) = 70.d0              ! LV_in
!      a(2) = 40.d0              ! LV_out
!      b(2) = 44.d0              ! LV_out
!      c(2) = 80.d0              ! LV_out
!      a(3) = 35.d0              ! RV_in
!      b(3) = 71.5d0             ! RV_in
!      c(3) = 55.d0              ! RV_in
!      a(4) = 40.d0              ! RV_out
!      b(4) = 77.d0              ! RV_out
!      c(4) = 60.d0              ! RV_out
!
!      a(1) = 20.d0              ! LV_in
!      b(1) = 20.d0              ! LV_in
!      c(1) = 62.d0              ! LV_in
!      a(2) = 32.d0              ! LV_out
!      b(2) = 32.d0              ! LV_out
!      c(2) = 74.d0              ! LV_out
!      a(3) = 23.d0              ! RV_in
!      b(3) = 51.d0              ! RV_in
!      c(3) = 51.d0              ! RV_in
!      a(4) = 28.d0              ! RV_out
!      b(4) = 56.d0              ! RV_out
!      c(4) = 56.d0              ! RV_out

!      a(1) = 28.d0              ! LV_in
!      b(1) = 28.d0              ! LV_in
!      c(1) = 62.d0              ! LV_in
!      a(2) = 40.d0              ! LV_out
!      b(2) = 40.d0              ! LV_out
!      c(2) = 74.d0              ! LV_out
!      a(3) = 23.d0              ! RV_in
!      b(3) = 51.d0              ! RV_in
!      c(3) = 51.d0              ! RV_in
!      a(4) = 28.d0              ! RV_out
!      b(4) = 56.d0              ! RV_out
!      c(4) = 56.d0              ! RV_out


c. LV
      a(1) = 20.d0              ! LV_in
      b(1) = 20.d0              ! LV_in
      c(1) = 62.d0              ! LV_in
      a(2) = 32.d0              ! LV_out
      b(2) = 32.d0              ! LV_out
      c(2) = 74.d0              ! LV_out
      a(3) = 23.d0              ! RV_in
      b(3) = 51.d0              ! RV_in
      c(3) = 51.d0              ! RV_in
      a(4) = 28.d0              ! RV_out
      b(4) = 56.d0              ! RV_out
      c(4) = 56.d0              ! RV_out


c
      tol = 1.d-6
c...  Check if the point belongs to LV
      res(1) = xr(1)*xr(1)/a(1)/a(1) 
     &       + xr(2)*xr(2)/b(1)/b(1) 
     &       + xr(3)*xr(3)/c(1)/c(1) - 1.d0
      res(2) = xr(1)*xr(1)/a(2)/a(2) 
     &       + xr(2)*xr(2)/b(2)/b(2) 
     &       + xr(3)*xr(3)/c(2)/c(2) - 1.d0
      xrad   = dsqrt(xr(1)*xr(1) + xr(2)*xr(2))
      cthe   = xr(1)/xrad
      sthe   = xr(2)/xrad
c 
c...  Account for the singularity at the apex by a threshold 
c...  ------------------------------------ Revised 02/05/10 SG    
C...  define the phi angles in the endo- and epicardium of ventricles 
      phimax(1) =  70.d0        ! LV endocardium 
      phimax(2) = -70.d0        ! LV epicardium 
      phimax(3) =  70.d0        ! RV endocardium 
      phimax(4) = -70.d0        ! RV epicardium 
      
c
c...  define threshold position in the longitudinal direction 
 !     zth(1)    =  58.d0        ! LV 
 !     zth(2)    =  54.d0        ! RV 

!      zth(1)    =  70.d0        ! LV 
!      zth(2)    =  55.d0        ! RV


      zth(1)    =  62.d0        ! LV 
      zth(2)    =  51.d0        ! RV 
c
      if (res(1).ge.tol.and.res(2).le.tol) then ! in LV
         is(1) = 1
         is(2) = 2 
c...  re-define phimax(i) depending upon the xr(3) value of the point 
C$$$         if (xr(3).gt.zth(1)) then 
C$$$            phimax(1) = phimax(1)
C$$$     &                * (1.d0 - (xr(3)-zth(1))/(c(2)-zth(1)))
C$$$            phimax(2) = phimax(2)
C$$$     &                * (1.d0 - (xr(3)-zth(1))/(c(2)-zth(1)))

C$$$            phimax(1) = 0.d0 
C$$$            phimax(2) = 0.d0 
C$$$         endif 
      else                      ! in RV
         is(1) = 3
         is(2) = 4
!         write(*,*) 'hi'
c...  re-define phimax(i) depending upon the xr(3) value of the point 
C$$$         if (xr(3).gt.zth(2)) then 
C$$$            phimax(3) = phimax(3)
C$$$     &                * (1.d0 - (xr(3)-zth(2))/(c(4)-zth(2)))
C$$$            phimax(4) = phimax(4)
C$$$     &                * (1.d0 - (xr(3)-zth(2))/(c(4)-zth(2)))

C$$$            phimax(3) = 0.d0 
C$$$            phimax(4) = 0.d0             
C$$$         endif 
      endif
      phi(1) =  datan(1.d0)*4.d0*phimax(is(1))/180.d0
      phi(2) =  datan(1.d0)*4.d0*phimax(is(2))/180.d0
c...  ------------------------------------ Revised 02/05/10 SG    
c
      do i =1,2
      alp(i) = 1.d0 - xr(3)*xr(3)/c(is(i))/c(is(i))
c     
      rad(i) = cthe*cthe/a(is(i))/a(is(i))/alp(i)
     &       + sthe*sthe/b(is(i))/b(is(i))/alp(i)
      if (rad(i).le.0.d0) rad(i) =1.d-3
      rad(i) = dsqrt(1.d0/rad(i))
      grad(i,1) = cthe*rad(i)/a(is(i))/a(is(i))/alp(i)
      grad(i,2) = sthe*rad(i)/b(is(i))/b(is(i))/alp(i)
      xnorm = dsqrt(grad(i,1)**2.d0 + grad(i,2)**2.d0)
      grad(i,1) = grad(i,1) / xnorm 
      grad(i,2) = grad(i,2) / xnorm 
      enddo 
c      
      xphi = phi(1) + (phi(2)-phi(1))*(xrad-rad(1))/(rad(2)-rad(1))
      cthe = grad(1,1) + 
     &      (grad(2,1)-grad(1,1))*(xrad-rad(1))/(rad(2)-rad(1))
      sthe = grad(1,2) + 
     &      (grad(2,2)-grad(1,2))*(xrad-rad(1))/(rad(2)-rad(1))
      xnorm = dsqrt(cthe**2.d0 + sthe**2.d0)
      cthe = cthe / xnorm 
      sthe = sthe / xnorm 
      xf(1) =  sthe * dcos(xphi)
      xf(2) = -cthe * dcos(xphi)
      xf(3) =        -dsin(xphi)
c
c...  sheet direction  = surface gradient (used in CNME paper)
c      xs(1) = -cthe 
c      xs(2) = -sthe 
c      xs(3) =  0.d0 
c...  sheet direction  = f0 x e3 surface gradient 
      norms = dabs(dsqrt(xf(1)**2.d0 + xf(2)**2.d0))
      xs(1) =  xf(2)/norms
      xs(2) = -xf(1)/norms 
      xs(3) =  0.d0 

!      xs(1) =  xf(2) 
!      xs(2) = -xf(1) 
!      xs(3) =  0.d0 
c
      elseif (ishp.eq.3) then   ! Beam/Plate examples
c...  angle between fiber axis and x-axis 
      angle = 0.d0 ! in deg
      xphi = angle/180.d0*(4.d0*atan(1.d0))
      xf(1) = dcos(xphi)
      xf(2) = 0.d0
      xf(3) = dsin(xphi)
c
      xs(1) = dsin(xphi) 
      xs(2) = 0.d0  
      xs(3) = -dcos(xphi) 
c
!     ROTH 2003: Figure 6 & Figure 7  
 
      elseif (ishp.eq.4) then   ! Roth & Beaudoin 2003 FIG 7 
c...  angle between fiber axis and x-axis  
	pi =  4.d0*datan(1.d0) 
!     ROTH 2003: Figure 6 & Figure 7 modified for 100 x 100  
	xphi = 0.5d0*pi*(dcos(pi*(xr(1)-50.d0)/100.d0))**2 
     *       * (dcos(pi*(xr(2)-50.d0)/100.d0))**2 

! ex1-2
!	xphi = 0.5d0*pi*(dcos(pi*(xr(1)-10.d0)/20.d0))**2 
!     *       * (dcos(pi*(xr(2)-10.d0)/20.d0))**2 

! ex3-4
!	xphi = pi*(dsin(2.d0*pi*(xr(1)-10.d0)/20.d0))**2 
!     *       * (dsin(2.d0*pi*(xr(2)-10.d0)/20.d0))**2 

      xf(1) = dcos(xphi) 
      xf(2) = dsin(xphi) 
      xf(3) = 0.d0 
c 
      xs(1) = dsin(xphi) !xphi !dsin(xphi)  
      xs(2) =-dcos(xphi)   
      xs(3) = 0.d0  

!     clyinder2
      elseif (ishp.eq.6) then   

     
c
      xrad   = dsqrt(((xr(1)-50.d0))**2.d0 + 
     *                ((xr(2)-50.d0))**2.d0)

      xphi  = datan( (xr(2)-50.d0)/(xr(1)-50.d0) )
      xm = 1.d0
      if((xr(2)-50.d0).lt.0.d0) xm = -1.d0

      xf(1) = sin(xphi)*cos(xphi) *xm
      xf(2) = -dcos(xphi)**2.d0*xm  ! xphi*180.d0/datan(1.d0)/4.d0
      xf(3) = 0.d0 

      norms = dabs(dsqrt(xf(1)**2.d0 + xf(2)**2.d0))  
      xf(1) = xf(1)/norms
      xf(2) = xf(2)/norms
      xf(3) = 0.d0 


c 
      norms = dabs(dsqrt(xf(1)**2.d0 + xf(2)**2.d0))
      xs(1) =  xf(2)/norms
      xs(2) = -xf(1)/norms 
      xs(3) =  0.d0   
      endif

 
      end



C$$$c...  fiber directions for cube2 
C$$$      phis = -datan(1.d0)*4.d0/3.d0
C$$$      phie =  datan(1.d0)*4.d0/3.d0
C$$$      lx   = 2.d0
C$$$      phi = phis + (phie-phis)*xr(1)/lx
C$$$      xf(1) = 0.d0
C$$$      xf(2) =  dsin(phi)
C$$$      xf(3) = -dcos(phi)
C$$$c...  fiber directions for cube1
C$$$      xf(1) = 1.d0
C$$$      xf(2) = 0.d0 
C$$$      xf(3) = 0.d0
C$$$c...  fiber directions for beam1
C$$$      xf(1) = 1.d0
C$$$      xf(2) = 0.d0 
C$$$      xf(3) = 0.d0
C$$$      if (xr(2).le.6.66d-1) then 
C$$$      xf(1) = 0.d0
C$$$      xf(2) = 0.d0 
C$$$      xf(3) = 0.d0
C$$$      endif
C$$$c...  fiber directions for beam2
C$$$      xf(1) = 0.d0
C$$$      xf(2) = 0.d0 
C$$$      xf(3) = 1.d0
C$$$      if (xr(2).le.6.66d-1) then 
C$$$      xf(1) = 0.d0
C$$$      xf(2) = 0.d0 
C$$$      xf(3) = 0.d0
C$$$      endif
C$$$c...  fiber directions for cylinder 
C$$$      phis =  datan(1.d0)*4.d0/3.d0
C$$$      phie = -datan(1.d0)*4.d0/3.d0
C$$$      xradi   = 18.d0
C$$$      xrado   = 30.d0
C$$$      xrad   = dsqrt(xr(1)*xr(1) + xr(2)*xr(2))
C$$$      phi = phis + (phie-phis)*(xrad-xradi)/(xrado-xradi)
C$$$c      write (*,*) xrad, phi/(datan(1.d0)*4.d0)*180.d0
C$$$      xf(1) = -xr(2)/xrad/dsqrt(1.d0+dcos(phi)*dcos(phi))
C$$$      xf(2) =  xr(1)/xrad/dsqrt(1.d0+dcos(phi)*dcos(phi))
C$$$      xf(3) =  dsin(phi)/dsqrt(1.d0+dcos(phi)*dcos(phi))
C$$$c    
C$$$      if (ix(nen1,elno).eq.2) then ! diag1 
C$$$          xf(1)=  0.535799245
C$$$          xf(2)=  0.143566975
C$$$          xf(3)=  0.832050294      
C$$$      endif
C$$$c     
C$$$      if (ix(nen1,elno).eq.3) then ! diag2 
C$$$         xf(1)= -0.362658953
C$$$         xf(2)=  0.203093573
C$$$         xf(3)=  0.909522669         
C$$$      endif

c...  plate example
C$$$      if (xref(2).gt.0.1d0) then 
C$$$         xf(1) = 1.d0/dsqrt(2.d0) 
C$$$         xf(2) = 0.d0 
C$$$         xf(3) = 1.d0/dsqrt(2.d0)  
C$$$      elseif (xref(2).lt.0.1d0) then 
C$$$         xf(1) =  1.d0/dsqrt(2.d0)  
C$$$         xf(2) =  0.d0 
C$$$         xf(3) = -1.d0/dsqrt(2.d0)  
C$$$      endif
c
c
c
c...  insert the rotated patch  
c      if (xr(3).le.50.d0.and.xr(3).ge.20.d0.and.
c     &      cthe.le.0.d0.and.cthe.ge.-0.8d0.and.
c     &      xr(2).gt.0.d0) phi = phi + 2.d0 *datan(1.d0)
c.... 
c






      subroutine ischemia(ng, flag) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng,flag
      double precision time,  x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 18.d0          ! rad_min 
!      xmax(1)  = 30.d0          ! rad_max 
!      xmin(2)  = 170.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 190.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0           ! z_min  
!      xmax(3) =  60.d0           ! z_max 

      xmin(1)  = 25.d0          ! rad_min 
      xmax(1)  = 50.d0          ! rad_max 
      xmin(2)  = 50.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 90.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  = 0.d0           ! z_min  
      xmax(3) =  30.d0           ! z_max 
       
      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) flag = 1 
 
!      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
!     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
!     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) flag = 1 
      end 



      subroutine ischemia2(ng, flag) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng,flag
      double precision time,  x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 18.d0          ! rad_min 
!      xmax(1)  = 30.d0          ! rad_max 
!      xmin(2)  = 170.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 190.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0           ! z_min  
!      xmax(3) =  60.d0           ! z_max 

      xmin(1)  = -20.d0          ! rad_min 
      xmax(1)  =  20.d0          ! rad_max 
      xmin(2)  = 0.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 360.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  = 50.d0           ! z_min  
      xmax(3) =  80.d0           ! z_max 
       
      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) flag = 1 
 

      end 


      subroutine ischemia3(ng, flag) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng,flag
      double precision time,  x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 18.d0          ! rad_min 
!      xmax(1)  = 30.d0          ! rad_max 
!      xmin(2)  = 170.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 190.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0           ! z_min  
!      xmax(3) =  60.d0           ! z_max 

      xmin(1)  = 33.d0          ! rad_min 
      xmax(1)  = 44.d0          ! rad_max 
      xmin(2)  = 225.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 265.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  =  0.d0           ! z_min  
      xmax(3) =  40.d0           ! z_max 
       
      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) flag = 1 
 

      end 



      subroutine ischemia4(ng, flag) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng,flag
      double precision time,  x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 18.d0          ! rad_min 
!      xmax(1)  = 30.d0          ! rad_max 
!      xmin(2)  = 170.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 190.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0           ! z_min  
!      xmax(3) =  60.d0           ! z_max 

      xmin(1)  = 50.d0          ! rad_min 
      xmax(1)  = 100.d0          ! rad_max 
      xmin(2)  = 245.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 305.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  =  0.d0           ! z_min  
      xmax(3) =  40.d0           ! z_max 
       
      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) flag = 1 
 

      end 



      subroutine ischemia5(ng, flag) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng, flag
      double precision time, curr, x0(3), xmin(4),xmax(4) 
c 

c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 

c...  define perturbation zone in polar coordinates  
      xmin(1)  = 40.d0 
      xmax(1)  = 50.d0 
      xmin(2)  =  5.d0  ! 30  !40    ! 0
      xmax(2)  = 50.d0  ! 55  !60    ! 50
      xmin(3)  =  0.d0 
      xmax(3)  = 20.d0 
c       
      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 2.5d0 
 
  
      return 
      end 


      subroutine stimulate_heart(time, curr) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng 
      double precision time, curr, x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 

      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 

c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 


!x      xmin(1)  = 115.d0          ! rad_min 
!x      xmax(1)  = 145.d0          ! rad_max 
!x      xmin(2)  = 80.d0
!x      xmax(2)  = 120.d0
!x      xmin(3)  = 0.d0           ! z_min  
!x      xmax(3) =  47.d0           ! z_max 
!x       
!x      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
!x     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
!x     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 35.d0 
 


!x      xmin(1)  = 100.d0          ! rad_min 
!x      xmax(1)  = 120.d0          ! rad_max 
!x      xmin(2)  = 90.d0
!x      xmax(2)  = 150.d0
!x      xmin(3)  = 10.d0           ! z_min  
!x      xmax(3) =  37.d0           ! z_max 
!x       
!x      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
!x     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
!x     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 25.d0 


      xmin(1)  = 80.d0          ! rad_min 
      xmax(1)  = 145.d0          ! rad_max 
      xmin(2)  = 90.d0
      xmax(2)  = 120.d0
      xmin(3)  = -10.d0           ! z_min  
      xmax(3) =  47.d0           ! z_max 
       
      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 35.d0 
 


!x      xmin(1)  = 80.d0          ! rad_min 
!x      xmax(1)  = 145.d0         ! rad_max 
!x      xmin(2)  = 90.d0
!x      xmax(2)  = 120.d0
!x      xmin(3)  = -10.d0           ! z_min  
!x      xmax(3) =  60.d0           ! z_max 
!x       
!x      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
!x     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
!x     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 35.d0 

      
      return 
      end 
 

      subroutine stimulate_heart2(ng, curr) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng 
      double precision time, curr, x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
  
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 33.d0          ! rad_min 
!      xmax(1)  = 44.d0          ! rad_max 
!      xmin(2)  = 275.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 295.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0             ! z_min  
!      xmax(3) =   2.0d0            ! z_max 



      xmin(1)  = 18.d0          ! rad_min 
      xmax(1)  = 25.d0          ! rad_max 
      xmin(2)  = 212.5d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 217.5d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  =  0.d0           ! z_min  
      xmax(3) =   1.5d0           ! z_max   



!x      xmin(1)  = 0.d0          ! rad_min 
!x      xmax(1)  = 5.d0          ! rad_max 
!x      xmin(2)  = 212.5d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!x      xmax(2)  = 217.5d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!x      xmin(3)  =  62.d0           ! z_min  
!x      xmax(3) =   77.d0           ! z_max   

      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 10.d0 !15.d0  !10.d0
 

      return 
      end 





      subroutine stimulate_heart3(ng, curr) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng 
      double precision time, curr, x0(3), xmin(4),xmax(4) 
      double precision the, sthe, cthe, rad, pi 
c 
      pi = 4.d0*datan(1.d0) 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
  
c...  compute the polar coordinates  
      rad = dsqrt(x0(1)*x0(1) + x0(2)*x0(2)) 
      cthe = x0(1)/rad 
      sthe = x0(2)/rad 
      the = dasin(dabs(sthe)) 
      if (sthe.gt.0.d0.and.cthe.lt.0.d0) then  
         the = pi - the 
      else if(sthe.lt.0.d0.and.cthe.lt.0.d0) then  
         the = pi + the 
      else if(sthe.lt.0.d0.and.cthe.gt.0.d0) then  
         the = 2.d0*pi - the 
      endif 
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 33.d0          ! rad_min 
!      xmax(1)  = 44.d0          ! rad_max 
!      xmin(2)  = 275.d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!      xmax(2)  = 295.d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!      xmin(3)  =  0.d0             ! z_min  
!      xmax(3) =   2.0d0            ! z_max 



!x      xmin(1)  = 18.d0          ! rad_min 
!x      xmax(1)  = 25.d0          ! rad_max 
!x      xmin(2)  = 212.5d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!x      xmax(2)  = 217.5d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!x      xmin(3)  =  0.d0           ! z_min  
!x      xmax(3) =   1.5d0           ! z_max   



!x      xmin(1)  = 0.d0          ! rad_min 
!x      xmax(1)  = 5.d0          ! rad_max 
!x      xmin(2)  = 212.5d0*4.d0*datan(1.d0)/180.d0 ! the_min 
!x      xmax(2)  = 217.5d0*4.d0*datan(1.d0)/180.d0 ! the_max 
!x      xmin(3)  =  62.d0           ! z_min  
!x      xmax(3) =   77.d0           ! z_max   



      xmin(1)  = 0.d0          ! rad_min 
      xmax(1)  = 5.d0          ! rad_max 
      xmin(2)  = 212.5d0*4.d0*datan(1.d0)/180.d0 ! the_min 
      xmax(2)  = 217.5d0*4.d0*datan(1.d0)/180.d0 ! the_max 
      xmin(3)  =  62.d0           ! z_min  
      xmax(3) =   77.d0           ! z_max   

      if (rad.ge.xmin(1).and.rad.le.xmax(1).and. 
     &    the.ge.xmin(2).and.the.le.xmax(2).and.  
     &  x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 15.d0  !10.d0
 

      return 
      end 




      subroutine stimulate_plate(time, curr) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng ,j
      double precision time, curr, x0(3), xmin(4),xmax(4) 
      real*8 cycle
c     
      xmin(4) = 0.d0         !435.d0           ! t_min 440 
      xmax(4) =999.d0        !455.d0           ! t_max 460 
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c



      cycle = 500.d0
      do j= 1,100
      if(time.gt.(j-1)*cycle.and.time.le.4.d0+(j-1)*cycle) then
c...  define perturbation zone in polar coordinates  
!      xmin(1)  = 66.d0   ! 67.d0 
       xmax(1)  = 2.7d0   ! 70.d0 
!      xmin(2)  = 0.d0  ! 30  !40    ! 0
!      xmax(2)  = 60.d0  ! 55  !60    ! 50
!      xmin(3)  =  0.d0 
!      xmax(3)  = 12.d0 
c       
c$$$      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
c$$$     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.               
c$$$     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr=80.d0 ! 40 - ex1
      if (x0(1).le.xmax(1)) curr=2.d0 ! 40 - ex1
         

      endif
      enddo

!      if (time.ge.8300) curr = 0.d0
      
c      write(*,*) 'hi'
      return 
      end 








      subroutine stimulate_plate2(ng, curr) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng 
      double precision time, curr, x0(3), xmin(4),xmax(4) 
c 

c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 

c...  define perturbation zone in polar coordinates  
      xmin(1)  =  0.d0 
      xmax(1)  =  2.5d0 
      xmin(2)  =  0.d0  ! 30  !40    ! 0
      xmax(2)  = 100.d0  ! 55  !60    ! 50
      xmin(3)  =  0.d0 
      xmax(3)  = 20.d0 
c       
      if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
     &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.                       ! x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) curr = 0.5d0 


      end 







 
      function dot2_sg(ndms,a,b) 
      implicit none 
      integer ndms 
      double precision a(ndms),b(ndms),dot2_sg 
      integer jj 
      double precision f(6) 
      data f/1.d0,1.d0,1.d0,2.d0,2.d0,2.d0/ 
c 
      dot2_sg = 0.d0 
      do 10 jj = 1,ndms 
   10   dot2_sg = dot2_sg + a(jj)*b(jj)*f(jj)  
      return 
      end 
 
 

      subroutine manipulate_plate(ng, diso,dort,xc,gamma,xmu1) 
      implicit none 
      include 'pointer.h' 
      include 'comblk.h' 
      include 'elcoor.h'        ! xref(3), xcur(3) 
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel 
c 
      integer ng 
      real*8 x0(3), xmin(7),xmax(7),diso,dort,xc,gamma,xmu1
c 
      x0(1) = xref(1) 
      x0(2) = xref(2) 
      x0(3) = xref(3) 
c 
c...  define perturbation zone in polar coordinates  
      xmin(1)  = 10.d0 
      xmax(1)  = 20.d0 
      xmin(2)  =  0.d0  
      xmax(2)  = 80.d0 
      xmin(3)  =  0.d0 
      xmax(3)  = 20.d0 

      xmin(4)  = 20.d0  ! x
      xmax(4)  = 30.d0  ! x
      xmin(5)  = 70.d0  ! y
      xmax(5)  = 80.d0  ! y

      xmin(6)  = 30.d0  ! x
      xmax(6)  = 40.d0  ! x
      xmin(7)  = 35.d0  ! y
      xmax(7)  = 70.d0  ! y

      
c       
 !     if (x0(1).ge.xmin(1).and.x0(1).le.xmax(1).and. 
 !    &    x0(2).ge.xmin(2).and.x0(2).le.xmax(2).and.  
 !    &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) then
 !        diso  = 0.d0 !diso*100.d0
 !        dort  = 0.d0 !dort*100.d0 
 !        xc    = 0.d0
 !        gamma = 0.d0
 !        xmu1  = 0.d0
 !     endif

      if (x0(1).ge.xmin(4).and.x0(1).le.xmax(4).and. 
     &    x0(2).ge.xmin(5).and.x0(2).le.xmax(5).and.  
     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) then
         diso  = 0.d0 !diso*100.d0
         dort  = 0.d0 !dort*100.d0 
         xc    = 0.d0
         gamma = 0.d0
         xmu1  = 0.d0
      endif


      if (x0(1).ge.xmin(6).and.x0(1).le.xmax(6).and. 
     &    x0(2).ge.xmin(7).and.x0(2).le.xmax(7).and.  
     &    x0(3).ge.xmin(3).and.x0(3).le.xmax(3)) then
         diso  = 0.d0 !diso*100.d0
         dort  = 0.d0 !dort*100.d0 
         xc    = 0.d0
         gamma = 0.d0
         xmu1  = 0.d0

      endif
 
      return 
      end 

c...  inverse of a general 3*3 matrix and determinant
      subroutine matinv(A, invA,detA)
      implicit none 
      double precision A(3,3) ,invA(3,3) ,detA
c     DET  =  a11(a33a22-a32a23)-a21(a33a12-a32a13)+a31(a23a12-a22a13)
      detA =  A(1,1)*(A(3,3)*A(2,2)-A(3,2)*A(2,3)) 
     *       -A(2,1)*(A(3,3)*A(1,2)-A(3,2)*A(1,3))
     *       +A(3,1)*(A(2,3)*A(1,2)-A(2,2)*A(1,3))
c###  Prevent division by zero 
       if (dabs(detA).le.1.d-16) then
           detA = 1.d-12
       endif  
c |   a33a22-a32a23  -(a33a12-a32a13)   a23a12-a22a13   |        
      invA(1,1) = (A(3,3)*A(2,2)-A(3,2)*A(2,3))/detA
      invA(1,2) =-(A(3,3)*A(1,2)-A(3,2)*A(1,3))/detA
      invA(1,3) = (A(2,3)*A(1,2)-A(2,2)*A(1,3))/detA
c |  -(a33a21-a31a23)   a33a11-a31a13  -(a23a11-a21a13) |
      invA(2,1) =-(A(3,3)*A(2,1)-A(3,1)*A(2,3))/detA
      invA(2,2) = (A(3,3)*A(1,1)-A(3,1)*A(1,3))/detA
      invA(2,3) =-(A(2,3)*A(1,1)-A(2,1)*A(1,3))/detA
c |   a32a21-a31a22  -(a32a11-a31a12)   a22a11-a21a12   |
      invA(3,1) = (A(3,2)*A(2,1)-A(3,1)*A(2,2))/detA
      invA(3,2) =-(A(3,2)*A(1,1)-A(3,1)*A(1,2))/detA 
      invA(3,3) = (A(2,2)*A(1,1)-A(2,1)*A(1,2))/detA
c
c | a11 a12 a13 |-1
c | a21 a22 a23 |    
c | a31 a32 a33 |               
c
c                |   a33a22-a32a23  -(a33a12-a32a13)   a23a12-a22a13  |
c     =  1/DET * | -(a33a21-a31a23)   a33a11-a31a13  -(a23a11-a21a13) |
c                |   a32a21-a31a22  -(a32a11-a31a12)   a22a11-a21a12  |

      return
      end

!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!       Subroutine For calculation of inverse of a 2nd order tensor     !
!              (symmetric positive definite) in vector form             !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
      subroutine inverse(A, invA,detA)
      implicit none 
      double precision A(6) ,invA(6) ,detA
	include 'iofile.h'  
! 
!      Convert to a matrix form
!       
!     DET  =  a11(a33a22-a32a23)-a21(a33a12-a32a13)+a31(a23a12-a22a13)
      detA =  A(1)*(A(3)*A(2)-A(5)*A(5)) 
     *       -A(4)*(A(3)*A(4)-A(5)*A(6))
     *       +A(6)*(A(5)*A(4)-A(2)*A(6))
!     Prevent division by zero 
       if (dabs(detA).le.1.d-16) then
           detA = 1.d-16
	write(iow,*) 'WARNING :determinant zero '
       endif
!    |a33a22-a32a23  -(a33a12-a32a13)   a23a12-a22a13   |        
      invA(1) = (A(3)*A(2)-A(5)*A(5))/detA
      invA(4) =-(A(3)*A(4)-A(5)*A(6))/detA
      invA(6) = (A(5)*A(4)-A(2)*A(6))/detA
! |  -(a33a21-a31a23)   a33a11-a31a13  -(a23a11-a21a13) |
!     invA(4) =-(A(3)*A(4)-A(6)*A(5))/detA
      invA(2) = (A(3)*A(1)-A(6)*A(6))/detA
      invA(5) =-(A(5)*A(1)-A(4)*A(6))/detA
! |   a32a21-a31a22  -(a32a11-a31a12)   a22a11-a21a12   |
!      invA(6) = (A(5)*A(4)-A(6)*A(2))/detA
!      invA(5) =-(A(5)*A(1)-A(6)*A(4))/detA 
      invA(3) = (A(2)*A(1)-A(4)*A(4))/detA
!
! | a11 a12 a13 |-1
! | a21 a22 a23 |    
! | a31 a32 a33 |               
!
!                |   a33a22-a32a23  -(a33a12-a32a13)   a23a12-a22a13  |
!     =  1/DET * | -(a33a21-a31a23)   a33a11-a31a13  -(a23a11-a21a13) |
!                |   a32a21-a31a22  -(a32a11-a31a12)   a22a11-a21a12  |
      return
      end


!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!	              Determinant of a 3x3 Matrix                       !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
      subroutine matdet(A, detA)
c     Determinant of a 3x3 matrix 
      implicit none 
      double precision A(3,3),detA
c     DET  =  a11(a33a22-a32a23)-a21(a33a12-a32a13)+a31(a23a12-a22a13)
      detA =  A(1,1)*(A(3,3)*A(2,2)-A(3,2)*A(2,3)) 
     *       -A(2,1)*(A(3,3)*A(1,2)-A(3,2)*A(1,3))
     *       +A(3,1)*(A(2,3)*A(1,2)-A(2,2)*A(1,3))
c###  Prevent division by zero 
       if (dabs(detA).le.1.d-16) then
           detA = 1.d-12
       endif
      return
      end


!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!	                 Apply External Shock                           !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
       subroutine defib(time, q)
       real*8 time, q(9), tmin, tmax,s_i,s_e

c...   Define shock time
       tmin = 10.d0
       tmax = 20.d0


       if(time.ge.tmin.and.time.le.tmax) then
c...   Apply shock to intra-cell
       s_i  = 5.d0     
       q(1) = q(1) + s_i
       q(2) = q(2) !+ s_i
       q(3) = q(3) !+ s_i 
c...   Apply shock to extra-cell
       s_e  = 0.d0 
       q(7) = q(7) + s_e
       q(8) = q(8) + s_e
       q(9) = q(9) + s_e 
       endif

       end
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!		     Pull Back Eulerian Stress                          !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
	subroutine pull_feap(tau,f,s)
	implicit none
	real*8 s(6),f(3,3),tau(6),  Inv_f(3,3), detf
	integer ij(3,3),a,b,d,e,I,J,K,L	
      data ij/ 1 , 4 , 6 ,
     *         4 , 2 , 5 ,
     *         6 , 5 , 3 /
!     Compute inverse of F			
        call matinv(f,Inv_f,detf)
!	Pull-Back Eulerian Stresssessubroutine pull_feap(tau,f,s)
	s=0.d0	
	do a = 1, 3		     
          do b = 1, a
	    do I = 1, 3
	      do J = 1, 3
          s(ij(a,b)) = s(ij(a,b)) + Inv_f(a,I)* Inv_f(b,J)* tau(ij(I,J))	
	      enddo
	    enddo
	   enddo
	 enddo
	return
	end





!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!               Push forward PK stress 2nd order tensor                 !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!

      
      subroutine push_forward_2nd(piola2_ab,F_ab,T_ab)
      implicit none
      real*8,dimension(3,3),intent(in) :: F_ab
      real*8,dimension(3,3),intent(in) :: T_ab
      real*8,dimension(3,3)            :: piola2_ab

      integer :: i,j,k,l,ii,jj,kk,ll
      
       piola2_ab = 0.d0
        do i=1,3
         do j=1,3
          do ii=1,3
           do jj=1,3
            piola2_ab(i,j) = piola2_ab(i,j)
     &                     + F_ab(i,ii)*F_ab(j,jj)*T_ab(ii,jj)
           end do
          end do
         end do
        end do

       end subroutine push_forward_2nd




      
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
!     Push forward moduli in Lagrangian setting (4th order tensor)      !
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!
            
      subroutine push_forward_4th(piola4_abcd,F_ab,T_abcd)
      implicit none
      real*8,dimension(3,3)    ,intent(in) :: F_ab
      real*8,dimension(3,3,3,3),intent(in) :: T_abcd
      real*8,dimension(3,3,3,3)            :: piola4_abcd

      integer :: i,j,k,l,ii,jj,kk,ll

      
       piola4_abcd = 0.d0
        do i=1,3
         do j=1,3
          do k=1,3
           do l=1,3
            do ii=1,3
             do jj=1,3
              do kk=1,3
               do ll=1,3
                piola4_abcd(i,j,k,l) = piola4_abcd(i,j,k,l) +
     &                F_ab(i,ii)*F_ab(j,jj)*F_ab(k,kk)*F_ab(l,ll)
     &               *T_abcd(ii,jj,kk,ll)
               end do
              end do
             end do
            end do
           end do
          end do
         end do
        end do

        end subroutine push_forward_4th

      
!-----------------------------------------------------------------------!
!-----------------------------------------------------------------------!




      subroutine voigtDyad(D1, v)

      implicit none
      real*8   D1(3,3), v(6)
      integer  i,j, ij(3,3)
      data ij/ 1 , 4 , 6 ,
     *         4 , 2 , 5 ,
     *         6 , 5 , 3 /

      do j = 1,3
        do i = 1,3
          v( ij(i,j) ) = D1(i,j)
        end do ! i
      end do ! j

      end

      
      subroutine voigtTetrade(T1, A) 
      implicit none 
      real*8 T1(3,3,3,3), A(6,6) 
      integer i,j,k,l, ij(3,3) 
      data ij/ 1 , 4 , 6 , 
     *         4 , 2 , 5 , 
     *         6 , 5 , 3 / 
      do l = 1,3
         do k = 1,3
            do j = 1,3 
               do i = 1,3
                  A( ij(i,j), ij(k,l) ) = T1(i,j,k,l)
               end do           ! i
            end do              ! j
         end do                 ! k
      end do                    ! l

      end subroutine voigtTetrade
      




















      subroutine voigtToTetrade(A1, T)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 2018-    : TU Dresden, Institut für Statik und
c                               Dynamik der Tragwerke
c                               All rights reserved
c....  Author: Johannes Storm

c-----[--.----+----.----+----.-----------------------------------------]
c     Modification log                                Date (dd/mm/year)
c       Original version                                    30/11/2018
c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose: Get tetrade from matrix in Voigt notation

c      Inputs:
c         A1(6,6)     - Voigt matrix

c      Outputs:
c         T(3,3,3,3)  - Tetrade
c-----[--.----+----.----+----.-----------------------------------------]
      implicit none

      real*8   A1(6,6), T(3,3,3,3)

      integer  i,j,k,l, ij(3,3)

      data ij/ 1 , 4 , 6 ,
     *         4 , 2 , 5 ,
     *         6 , 5 , 3 /

      do l = 1,3
        do k = 1,3
          do j = 1,3
            do i = 1,3
              T(i,j,k,l) = A1( ij(i,j), ij(k,l) )
            end do ! i
          end do ! j
        end do ! k
      end do ! l

      end
      









      
      subroutine demo(a,b,c)
      implicit none
      real*8 a(3,3),b(3,3),c(3,3)

      a=b+c
      end subroutine demo
