c$Id: elmt01.f,v 1.1 2004/01/11 19:11:33 rlt Exp $
      subroutine elmt02(d,ul,xl,ix,tl,s,p,ndf,ndm,nst,isw)
 
c      * * F E A P * * A Finite Element Analysis Program
 
c....  Copyright (c) 1984-2004: Regents of the University of California
c                               All rights reserved
c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose: 3-D finite deformation displacement element
c      Remark: This a completely standard mechanical element
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none
 
      include  'bdata.h'
      include  'cdata.h'        !numnp,numel,nummat,nen,neq,ipr
      include  'cdat1.h'
      include  'cdamag.h'
      include  'debugs.h'
      include  'elcoor.h'
      include  'eldata.h'       !dm,n,ma,mct,iel,nel
      include  'elengy.h'
      include  'elplot.h'
      include  'eltran.h'
      include  'hdata.h'
      include  'iofile.h'
      include  'ndata.h'
      include  'part0.h'
      include  'pglob1.h'
      include  'plast3f.h'
      include  'pmod2d.h'
      include  'prld1.h'
      include  'prstrs.h'
      include  'ptdat6.h'
      include  'rdata.h' 
      include  'tdata.h'
      include  'comblk.h'
c
      include 'counts.h'
c
      include 'strnum.h'   !common /strnum/ istv, iste, istp
 
!      include  'qudshp.h'
 
      integer ix(*), ndf,ndm,nst,isw, i,ii,i1, j,jj,j1,k, ngp,k2
      integer l, nhv,nn,nhi,istrt,lint, ord,nhlo,nhln,nhist,nhli
      real*8  bdb, xipa,wena
      real*8  d(*),tl(*),ul(ndf,nen,*),xl(ndm,*),s(nst,*),p(ndf,*)
      real*8  sg(4,125),sv(5,16),sj(125),xx(3)
      real*8  f(9,2,125),finv(3,3,125),df(3,3,125),detfi(2,125)
      real*8  shp(4,27,125),xsj(125)
      real*8  aa(6,6,5),dd(6,6,125), xu(3,125)
      real*8  sigv(20),sigl(10,125), sigp(20,125)
      real*8  bbd(3,6),r1(3,125), vv(5)
      real*8  dvol(125),dvol0(125),xr(3,125),ur(3,125)
c
      real*8 theta,vol0,vol,shpa(3,8),xkap,ph,dph
c
      real*8  phi(125), phidot(125), gphi(3,125), xh(3,125)
      real*8  fphi(125), fphip(125)
      real*8  c12(3,3,125), c22(6,125), c21(3,6,125), c21_2(6,125)
c
      real*8  xf(3), xs(3),xn(3),xnorm,xnormn,xq3,xq2
      integer n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,n11,n12,n13,n14,n15,n16
      real*8 seg,time,N_tau_N,xphi
      save
 
 
 
cccc
c.... set number of projected stresses (iste=nr,istv=max nr) 
c...  for extra projections
      iste = 20
      istv = iste
c
c     initialize variables related to volume change and   average shape functions
      vol0  = 0.d0
      vol   = 0.d0
      shpa  = 0.d0
 
      
ccc
       if (isw.eq.12) return  ! bc
cccc
c     MATERIAL DATA
      if(isw.eq.1) then
         write(*,2000)
         call umati02('elec',vv,d,d(ndd-nud+1),nh1,nh3)
         nhist = 7 ! 3 + 3
         ngp   = 8 ! number of gaus points 
         nh1 = ngp*nhist  ! time dependent history at tn
         nh2 = nh1        ! time dependent history at tn+1
         nh3 = ngp*nh3    ! time independent history 
c.... perform some initializations
         stype = d(16)
         etype = d(17)
         dtype = d(18) 
c         hflag = d(30).eq.1.0d0         
c     Set plot sequence for 4/10-nod tet or 8/27-node bricks         
         if(nen.eq.4) then
            call pltet4(iel)
         elseif(nen.eq.10) then
            call pltet10(iel)
         elseif(nen.eq.27) then
            call plbk27(iel)
         else
            call plbrk8(iel)
         endif
        
         
c     COMPUTE TANGENT STIFFNESS AND RESIDUAL FORCE VECTOR
      else ! isw.neq.1
  
 
c     Get quadrature information
         if(nel.eq.4) then
            ord = 1
            call tint3d(ord,lint,sv)
         elseif(nel.eq.10) then
            ord = 2
            call tint3d(3,lint,sv)
         elseif(nel.eq.8) then
            ord = 0
            d(5)= 2.d0          ! Number Gauss points in each dir. 
            l   = nint(d(5))
            call int3d(l,lint,sg)
         endif
 
c     Compute shape functions
         do l = 1,lint
            if(ord.gt.0) then
               call tetshp(sv(1,l),xl,ndm,nel,xsj(l),shp(1,1,l))
               dvol0(l) = xsj(l)*sv(5,l)
            else
               call shp3d(sg(1,l),xsj(l),shp(1,1,l),xl,ndm,nel)
               dvol0(l) = xsj(l)*sg(4,l) ! undeformed element volume at gauss point, xsj - jacobian, sg - weight
            endif
         end do                 ! l
 
c       Compute coordinates
 
        do l = 1,lint
          do i = 1,3
            xr(i,l) = 0.0d0
            ur(i,l) = 0.0d0
            do j = 1,nel
              xr(i,l) = xr(i,l) + shp(4,j,l)*xl(i,j)
              ur(i,l) = ur(i,l) + shp(4,j,l)*ul(i,j,1)
            end do ! j
            ur(i,l) =  xr(i,l)
          end do ! i
        end do ! l
         
 
c       Degrees of freedom with enhanced modes.
 
        nhv   = nint(d(15))
        istrt = nint(d(84))
 
c       Initialize history variables
 
        if(isw.eq.14) then
 
 
 
          
          do l = 1,lint
 
      if (nstep.eq.0.and.niter.eq.0) then 
c...  set the initial microstructural data in the history field 
c...  compute fiber,sheet and normal directions, and store them for all 
       call comp_micr(xr(1,l), xf,xs, 4)  ! 2-Heart 3-Plate 4-Example Roth 5-Beam
                                      ! 
       xnorm = dabs(xf(1)*xs(1) + xf(2)*xs(2) + xf(3)*xs(3))
!       if (xnorm.ge.1.d-8) write(*,*) "non-perpendicular:", xnorm
c...  compute normal direction
c...  n_0 = f_0 x s_0
       xn(1) = xf(2)*xs(3) - xf(3)*xs(2)
       xn(2) = xf(3)*xs(1) - xf(1)*xs(3)
       xn(3) = xf(1)*xs(2) - xf(2)*xs(1) 
       xnormn = dabs(dsqrt( xn(1)**2.d0 + xn(2)**2.d0 + xn(3)**2.d0 ))
c...  normalize
       xn(1) = xn(1)/xnormn
       xn(2) = xn(2)/xnormn
       xn(3) = xn(3)/xnormn 
       xnormn = dabs(dsqrt(xn(1)**2.d0 + xn(2)**2.d0 + xn(3)**2.d0 )) 
!      if (dabs(xnormn-1.d0).ge.1.d-8)write(*,*)"n is not unity:",xnormn
c...  set the microstructure in the history field
      do k = 1,3
        nhli = (l-1)*11 + nh3 + k - 1  
        hr(nhli)   = xf(k) 
        hr(nhli+3) = xs(k)
        hr(nhli+6) = xn(k)
      enddo
 
      endif !nstep
 
c...  end: set the initial microstructural data in the history field 
c           Compute Cauchy stresses and spatial tangent tensor at t-n+1
 
             do i = 1,9
                f(i,1,l)    = 0.0d0
                f(i,2,l)    = 0.0d0
                finv(i,1,l) = 0.0d0
             end do             ! i
             detfi(1,l)  = 1.d0
             detfi(2,l)  = 1.d0
             do i = 1,9,4
                f(i,1,l)    = 1.0d0
                f(i,2,l)    = 1.0d0
             end do             ! i
            finv(1,1,l) = 1.0d0
            finv(2,2,l) = 1.0d0
            finv(3,3,l) = 1.0d0
            
         end do                 ! l
         
        else ! if isw.ne.14
              
c     Compute deformation gradient, inverse and determinant.
           do l = 1,lint
             call kine3df(shp(1,1,l),ul,f(1,1,l),finv(1,1,l),df(1,1,l),
     &            detfi(1,l),ndf,nel,nen)
            dvol(l) = dvol0(l)*detfi(1,l)         ! deformed element volume at gauss point 
         end do                 ! l
      endif
 
c     Compute action potential, its rate and spatial gradient
        do l = 1,lint
           phi(   l) = 0.0d0 
           phidot(l) = 0.0d0 
           do i = 1,nel
              phi(   l) = phi(   l) + shp(4,i,l)*ul(4,i,1)
              phidot(l) = phidot(l) + shp(4,i,l)*ul(4,i,2)/dt
           end do               !i
           do j =1,ndm
              gphi(j,l) = 0.d0
              do i = 1,nel
                 gphi(j,l) = gphi(j,l) + shp(j,i,l)*ul(4,i,1)
              end do            ! i
           end do               ! j
 
 
        end do                  ! l
 
 
c     Compute Cauchy stresses and spatial tangent tensor at t-n+1      
      nhi = 0
      nn  = nhi
c-------------------------------------------
c--------- LOOP OVER GAUSS POINTS (I) ------
c-------------------------------------------
      do l = 1,lint
 
c     Zero stress and moduli          
          do i = 1,6
             do j = 1,6
                aa(j,i,1) = 0.0d0
                aa(j,i,2) = 0.0d0
                aa(j,i,3) = 0.0d0
                aa(j,i,4) = 0.0d0
                aa(j,i,5) = 0.0d0
             end do             ! j
          end do                ! i
 
c     pass spatial gradient of action potential in sigv(11-13)
          sigv(11) = gphi(1,l)
          sigv(12) = gphi(2,l)
          sigv(13) = gphi(3,l)
c
          do i = 1,3
          xref(i) = xr(i,l)
          xcur(i) = xr(i,l)  !+ ur(i,l)
          end do                ! i
 
 
          nhlo = (l-1)*nhist + nh1
          nhln = (l-1)*nhist + nh2
          nhli = (l-1)*11     + nh3
!      if(n.eq.1.or.n.eq.1002) write(*,*) hr(nh1),hr(nh2),n
c     pass the quadrature point number: 
          call umatl02(f(1,1,l),detfi(1,l),phi(l),d, d(ndd-nud+1),
     &                  hr(nhlo),hr(nhln),hr(nhli),nhv,1,l, sigv,aa,isw)
c     get flux term sigv(11-13) and sensitivities 
          xh(1,l) = sigv(11) *dvol0(l)
          xh(2,l) = sigv(12) *dvol0(l)
          xh(3,l) = sigv(13) *dvol0(l)
c       
     
 
c...  get the electrical body force 
          fphi( l) = aa(1,3,2)*dvol0(l)
          fphip(l) = aa(2,3,2)*dvol0(l)
 
c...  get the Elec-Elec Sensitivity (conduct.)
          c22(1,l) = aa(1,2,2)*dvol0(l)
          c22(2,l) = aa(2,2,2)*dvol0(l)
          c22(3,l) = aa(3,2,2)*dvol0(l)
          c22(4,l) = aa(4,2,2)*dvol0(l)
          c22(5,l) = aa(5,2,2)*dvol0(l)
          c22(6,l) = aa(6,2,2)*dvol0(l)
 
c       Store time history plot data for element 
          k = 6*(l-1)
          do i = 1,6
            tt(i+k)   = sigv(i)
            sigp(i,l) = sigv(i)
            sigl(i,l) = sigv(i)*dvol(l)
            do j = 1,6
              dd(j,i,l) = aa(j,i,1)*dvol(l)
            end do ! j
          end do ! i
c...  For extra projections (starting from 14..20)
          do i = 14,20
            sigp(i,l) = sigv(i)
          enddo
          nn = nn + nhv
 
        end do ! l
c-------------------------------------------
c----------- END OF LOOP (I)  --------------
c-------------------------------------------
 
        if(isw.eq.13) then
c...  Do nothing!
        else
 
c     STIFFNESS AND RESIDUAL
 
          if(isw.eq.3 .or. isw.eq.6) then
c-------------------------------------------
c--------- LOOP OVER GAUSS POINTS (II) -----
c-------------------------------------------
            do l = 1,lint
 
c             COMPUTE STRESS DIVERGENCE TERM
 
c             Compatible internal force: [B_i]^T [tau]
              do i = 1,nel
c$$$                r1(1,i) = shp(1,i,l)*sigl(1,l)
c$$$     &                  + shp(2,i,l)*sigl(4,l)
c$$$     &                  + shp(3,i,l)*sigl(6,l)
c$$$ 
c$$$                r1(2,i) = shp(1,i,l)*sigl(4,l)
c$$$     &                  + shp(2,i,l)*sigl(2,l)
c$$$     &                  + shp(3,i,l)*sigl(5,l)
c$$$ 
c$$$                r1(3,i) = shp(1,i,l)*sigl(6,l)
c$$$     &                  + shp(2,i,l)*sigl(5,l)
c$$$     &                  + shp(3,i,l)*sigl(3,l)
 
                 p(1,i) = p(1,i)-shp(1,i,l)*sigl(1,l)
     &                 - shp(2,i,l)*sigl(4,l)
     &                  - shp(3,i,l)*sigl(6,l)
 
                p(2,i) = p(2,i)-shp(1,i,l)*sigl(4,l)
     &                  -shp(2,i,l)*sigl(2,l)
     &                  -shp(3,i,l)*sigl(5,l)
 
                p(3,i) = p(3,i)-shp(1,i,l)*sigl(6,l)
     &                  -shp(2,i,l)*sigl(5,l)
     &                  - shp(3,i,l)*sigl(3,l)
 
 
 
c..   and the force term form electrical part 
           p(4,i)  = p(4,i) 
     &       - shp(4,i,l)*phidot(l) *dvol0(l)
     &       - shp(1,i,l)*xh(1,l)-shp(2,i,l)*xh(2,l)-shp(3,i,l)*xh(3,l) 
     &       + shp(4,i,l)*fphi(l)
 
             end do                  ! i
             
c     COMPUTE K11             
             if(isw.eq.3) then
                i1 = 0
                do i = 1,nel
c     PART 1. - geometric  part.                   
                   j1 = 0
                   do j = 1,nel                      
c$$$                     bdb = (  r1(1,i)*shp(1,j,l)
c$$$     &                      + r1(2,i)*shp(2,j,l)
c$$$     &                     + r1(3,i)*shp(3,j,l) )
 
c$$$
c$$$                            N_tau_N =
c$$$     &       +shp(1,i,l)*sigv(1)*shp(1,j,l)*dvol(l)
c$$$     &       +shp(2,i,l)*sigv(4)*shp(1,j,l)*dvol(l)         
c$$$     &       +shp(3,i,l)*sigv(6)*shp(1,j,l)*dvol(l)
c$$$     &       +shp(1,i,l)*sigv(4)*shp(2,j,l)*dvol(l)
c$$$     &       +shp(2,i,l)*sigv(2)*shp(2,j,l)*dvol(l)             
c$$$     &       +shp(3,i,l)*sigv(5)*shp(2,j,l)*dvol(l)     
c$$$     &       +shp(1,i,l)*sigv(6)*shp(3,j,l)*dvol(l)
c$$$     &       +shp(2,i,l)*sigv(5)*shp(3,j,l)*dvol(l)      
c$$$     &       +shp(3,i,l)*sigv(3)*shp(3,j,l)*dvol(l)
                            N_tau_N =
     &       +shp(1,i,l)*sigl(1,l)*shp(1,j,l)
     &       +shp(2,i,l)*sigl(4,l)*shp(1,j,l)
     &       +shp(3,i,l)*sigl(6,l)*shp(1,j,l)
     &       +shp(1,i,l)*sigl(4,l)*shp(2,j,l)
     &       +shp(2,i,l)*sigl(2,l)*shp(2,j,l)
     &       +shp(3,i,l)*sigl(5,l)*shp(2,j,l)
     &       +shp(1,i,l)*sigl(6,l)*shp(3,j,l)
     &       +shp(2,i,l)*sigl(5,l)*shp(3,j,l)
     &       +shp(3,i,l)*sigl(3,l)*shp(3,j,l)          
 
                            
                     do jj = 1,3
                        s(i1+jj,j1+jj) = s(i1+jj,j1+jj)+ n_tau_n
                     end do     ! jj
                     j1 = j1 + ndf
                  end do        ! j                                    
c     PART 2. - material part
                  do jj = 1,6
                    bbd(1,jj) = shp(1,i,l)*dd(1,jj,l)
     &                        + shp(2,i,l)*dd(4,jj,l)
     &                        + shp(3,i,l)*dd(6,jj,l)
                    bbd(2,jj) = shp(1,i,l)*dd(4,jj,l)
     &                        + shp(2,i,l)*dd(2,jj,l)
     &                        + shp(3,i,l)*dd(5,jj,l)
                    bbd(3,jj) = shp(1,i,l)*dd(6,jj,l)
     &                        + shp(2,i,l)*dd(5,jj,l)
     &                        + shp(3,i,l)*dd(3,jj,l)
                  end do ! jj
                  j1 = 0
                  do j  = 1,nel
 
! make use of symmetry bc
                      ! 11
c$$$                      s(i1+1,j1+1) = s(i1+1,j1+1)
c$$$     &                              + bbd(1,1)*shp(1,j,l)
c$$$     &                              + bbd(1,4)*shp(2,j,l)
c$$$     &                              + bbd(1,6)*shp(3,j,l)
 
                      ! 22
     
c$$$                      s(i1+2,j1+2) = s(i1+2,j1+2)
c$$$     &                              + bbd(2,4)*shp(1,j,l)
c$$$     &                              + bbd(2,2)*shp(2,j,l)
c$$$     &                              + bbd(2,5)*shp(3,j,l)
                      ! 33
c$$$                      s(i1+3,j1+3) = s(i1+3,j1+3)
c$$$     &                              + bbd(3,6)*shp(1,j,l)
c$$$     &                              + bbd(3,5)*shp(2,j,l)
c$$$     &                              + bbd(3,3)*shp(3,j,l)
                      ! 12 - 21
                      s(i1+1,j1+2) = s(i1+1,j1+2)
     &                              + bbd(1,4)*shp(1,j,l)
     &                              + bbd(1,2)*shp(2,j,l)
     &                              + bbd(1,5)*shp(3,j,l)
                      s(j1+2,i1+1) = s(i1+1,j1+2)
                      ! 23 - 32
                      s(i1+2,j1+3) = s(i1+2,j1+3)
     &                              + bbd(2,6)*shp(1,j,l)
     &                              + bbd(2,5)*shp(2,j,l)
     &                              + bbd(2,3)*shp(3,j,l)
                      s(j1+3,i1+2) = s(i1+2,j1+3)
                      ! 13 - 31
                      s(i1+1,j1+3) = s(i1+1,j1+3)
     &                              + bbd(1,6)*shp(1,j,l)
     &                              + bbd(1,5)*shp(2,j,l)
     &                              + bbd(1,3)*shp(3,j,l)
                      s(j1+3,i1+1) = s(i1+1,j1+3)
!     !
      s(i1+1,j1+1) =s(i1+1,j1+1) ! 11
     &           +shp(1,i,l)*dd(1,1,l)*shp(1,j,l)
     &           +shp(2,i,l)*dd(4,1,l)*shp(1,j,l)
     &           +shp(3,i,l)*dd(6,1,l)*shp(1,j,l)
     &           +shp(1,i,l)*dd(1,4,l)*shp(2,j,l)
     &           +shp(2,i,l)*dd(4,4,l)*shp(2,j,l)
     &           +shp(3,i,l)*dd(6,4,l)*shp(2,j,l)
     &           +shp(1,i,l)*dd(1,6,l)*shp(3,j,l)
     &           +shp(2,i,l)*dd(4,6,l)*shp(3,j,l)
     &           +shp(3,i,l)*dd(6,6,l)*shp(3,j,l)
          
 
c$$$     
 
c$$$    
 
c$$$    
          s(i1+2,j1+2) =s(i1+2,j1+2)!22
     &         +shp(1,i,l)*dd(4,4,l)*shp(1,j,l)
     &         +shp(1,i,l)*dd(4,2,l)*shp(2,j,l)
     &         +shp(1,i,l)*dd(4,5,l)*shp(3,j,l)
     &         +shp(2,i,l)*dd(2,4,l)*shp(1,j,l)
     &         +shp(2,i,l)*dd(2,2,l)*shp(2,j,l)
     &         +shp(2,i,l)*dd(2,5,l)*shp(3,j,l)
     &         +shp(3,i,l)*dd(5,4,l)*shp(1,j,l)
     &         +shp(3,i,l)*dd(5,2,l)*shp(2,j,l)
     &         +shp(3,i,l)*dd(5,5,l)*shp(3,j,l)
c$$$
c$$$     
 
c$$$     
c$$$     
       s(i1+3,j1+3) =s(i1+3,j1+3)!33
     &      +shp(1,i,l)*dd(6,6,l)*shp(1,j,l)
     &      +shp(1,i,l)*dd(6,5,l)*shp(2,j,l)
     &      +shp(1,i,l)*dd(6,3,l)*shp(3,j,l)
     &      +shp(2,i,l)*dd(5,6,l)*shp(1,j,l)
     &      +shp(2,i,l)*dd(5,5,l)*shp(2,j,l)
     &      +shp(2,i,l)*dd(5,3,l)*shp(3,j,l)
     &      +shp(3,i,l)*dd(3,6,l)*shp(1,j,l)
     &      +shp(3,i,l)*dd(3,5,l)*shp(2,j,l)
     &      +shp(3,i,l)*dd(3,3,l)*shp(3,j,l)
 
 
 
 
c$$$
c$$$       
c$$$      s(i1+1,j1+2) =s(i1+1,j1+2) ! 12
c$$$     &           +shp(1,i,l)*dd(1,4,l)*shp(1,j,l)
c$$$     &           +shp(2,i,l)*dd(4,4,l)*shp(1,j,l)
c$$$     &           +shp(3,i,l)*dd(6,4,l)*shp(1,j,l)
c$$$     &           +shp(1,i,l)*dd(1,2,l)*shp(2,j,l)
c$$$     &           +shp(2,i,l)*dd(4,2,l)*shp(2,j,l)
c$$$     &           +shp(3,i,l)*dd(6,2,l)*shp(2,j,l)
c$$$     &           +shp(1,i,l)*dd(1,5,l)*shp(3,j,l)
c$$$     &           +shp(2,i,l)*dd(4,5,l)*shp(3,j,l)
c$$$     &           +shp(3,i,l)*dd(6,5,l)*shp(3,j,l)
c$$$      s(i1+2,j1+1) =s(i1+1,j1+2) ! 12
c$$$
c$$$       s(i1+2,j1+3) =s(i1+2,j1+3)!23
c$$$     &       +shp(1,i,l)*dd(4,6,l)*shp(1,j,l)
c$$$     &       +shp(2,i,l)*dd(2,6,l)*shp(1,j,l)
c$$$     &       +shp(3,i,l)*dd(5,6,l)*shp(1,j,l)
c$$$     &       +shp(1,i,l)*dd(4,5,l)*shp(2,j,l)
c$$$     &       +shp(2,i,l)*dd(2,5,l)*shp(2,j,l)
c$$$     &       +shp(3,i,l)*dd(5,5,l)*shp(2,j,l)
c$$$     &       +shp(1,i,l)*dd(4,3,l)*shp(3,j,l)
c$$$     &       +shp(2,i,l)*dd(2,3,l)*shp(3,j,l)
c$$$     &       +shp(3,i,l)*dd(5,3,l)*shp(3,j,l)
c$$$       s(i1+3,j1+2) =s(i1+2,j1+3)!32
c$$$       
c$$$        s(i1+1,j1+3) =s(i1+1,j1+3) !13
c$$$     &           +shp(1,i,l)*dd(1,6,l)*shp(1,j,l)
c$$$     &           +shp(2,i,l)*dd(4,6,l)*shp(1,j,l)
c$$$     &           +shp(3,i,l)*dd(6,6,l)*shp(1,j,l)
c$$$     &           +shp(1,i,l)*dd(1,5,l)*shp(2,j,l)
c$$$     &           +shp(2,i,l)*dd(4,5,l)*shp(2,j,l)
c$$$     &           +shp(3,i,l)*dd(6,5,l)*shp(2,j,l)
c$$$     &           +shp(1,i,l)*dd(1,3,l)*shp(3,j,l)
c$$$     &           +shp(2,i,l)*dd(4,3,l)*shp(3,j,l)
c$$$     &           +shp(3,i,l)*dd(6,3,l)*shp(3,j,l)
c$$$         s(i1+3,j1+1) =s(i1+1,j1+3) !31
c$$$
c$$$
 
 
 
 
 
 
 
          
c$$$       s(i1+1,j1+2) =s(i1+1,j1+2)  ! 12
c$$$     &           +shp(1,i,l)*aa(1,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(1,i,l)*aa(1,2,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(1,i,l)*aa(1,5,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(2,i,l)*aa(4,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(2,i,l)*aa(4,2,1)*shp(2,j,l)*dvol(l) 
c$$$     &           +shp(2,i,l)*aa(4,5,1)*shp(3,j,l)*dvol(l)       
c$$$     &           +shp(3,i,l)*aa(6,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(3,i,l)*aa(6,2,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(3,i,l)*aa(6,5,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$        s(i1+2,j1+1) =s(i1+1,j1+2)!21       
c$$$  
c$$$    
c$$$        s(i1+1,j1+3) =s(i1+1,j1+3) !13
c$$$     &           +shp(1,i,l)*aa(1,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(1,i,l)*aa(1,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(1,i,l)*aa(1,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(2,i,l)*aa(4,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(2,i,l)*aa(4,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(2,i,l)*aa(4,3,1)*shp(3,j,l)*dvol(l)    !
c$$$     &           +shp(3,i,l)*aa(6,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(3,i,l)*aa(6,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &           +shp(3,i,l)*aa(6,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$         s(i1+3,j1+1) =s(i1+1,j1+3) !31
c$$$    
c$$$          s(i1+2,j1+2) =s(i1+2,j1+2)!22
c$$$     &         +shp(1,i,l)*aa(4,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(1,i,l)*aa(4,2,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(1,i,l)*aa(4,5,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(2,i,l)*aa(2,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(2,i,l)*aa(2,2,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(2,i,l)*aa(2,5,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(3,i,l)*aa(5,4,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(3,i,l)*aa(5,2,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &         +shp(3,i,l)*aa(5,5,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$
c$$$     
c$$$       s(i1+2,j1+3) =s(i1+2,j1+3)!23
c$$$     &       +shp(1,i,l)*aa(4,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(1,i,l)*aa(4,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(1,i,l)*aa(4,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(2,i,l)*aa(2,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(2,i,l)*aa(2,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(2,i,l)*aa(2,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)      
c$$$     &       +shp(3,i,l)*aa(5,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(3,i,l)*aa(5,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &       +shp(3,i,l)*aa(5,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$        s(i1+3,j1+2) =s(i1+2,j1+3)!32
c$$$     
c$$$     
c$$$       s(i1+3,j1+3) =s(i1+3,j1+3)!33
c$$$     &      +shp(1,i,l)*aa(6,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(1,i,l)*aa(6,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(1,i,l)*aa(6,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(2,i,l)*aa(5,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(2,i,l)*aa(5,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(2,i,l)*aa(5,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)      
c$$$     &      +shp(3,i,l)*aa(3,6,1)*shp(1,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(3,i,l)*aa(3,5,1)*shp(2,j,l)*dvol(l)    ! *(-1.d0)
c$$$     &      +shp(3,i,l)*aa(3,3,1)*shp(3,j,l)*dvol(l)    ! *(-1.d0)
 
     
 
 
                     
c...  Coupling part ! make use of symmetry  bc
 
                      s(i1+1,j1+4) = 0.d0
                      s(i1+2,j1+4) = 0.d0
                      s(i1+3,j1+4) = 0.d0
            s(i1+4,j1+1) = 0.d0
            s(i1+4,j1+2) = 0.d0
            s(i1+4,j1+3) = 0.d0
 
c
            j1 = j1 + ndf
         end do                 ! j
 
          j1 = 0
          do j = 1,i ! make use of symmetry bc
                    s(i1+4,j1+4) = 0.d0 !s(i1+4,j1+4)
c$$$     &                   + shp(4,i,l)*shp(4,j,l)*dvol0(l)/dt
c$$$     &                   + c22(1,l)*shp(1,i,l)*shp(1,j,l)
c$$$     &                   + c22(2,l)*shp(2,i,l)*shp(2,j,l)
c$$$     &                   + c22(3,l)*shp(3,i,l)*shp(3,j,l)
c$$$     &                   + c22(4,l)*shp(1,i,l)*shp(2,j,l)
c$$$     &                   + c22(5,l)*shp(2,i,l)*shp(3,j,l)
c$$$     &                   + c22(6,l)*shp(1,i,l)*shp(3,j,l)
c$$$     &                   + c22(4,l)*shp(2,i,l)*shp(1,j,l)
c$$$     &                   + c22(5,l)*shp(3,i,l)*shp(2,j,l)
c$$$     &                   + c22(6,l)*shp(3,i,l)*shp(1,j,l)
c$$$     &                   - shp(4,i,l)*shp(4,j,l)*fphip(l)
           if (j.ne.i)  s(j1+4,i1+4) = s(i1+4,j1+4)
           j1 = j1 + ndf
          enddo ! j
!!
 
         i1 = i1 + ndf
      end  do                   ! i
      
      endif ! isw.eq.3
 
            end do ! l
c-------------------------------------------
c----------- END OF LOOP (II) --------------
c-------------------------------------------
 
c         OUTPUT STRESSES
 
          elseif(isw.eq.4 .or. isw.eq.8 .or. isw.eq.16) then
            xipa = 0.0d0
            wena = 0.0d0
            do i = 1,3
              xx(i) = 0.0d0
            end do ! i
            do i = 1,13
              sigv(i) = 0.0d0
            end do ! i
 
            do l = 1,lint
 
              do j = 1,3
                do i=1,nel
                  xx(j)   = xx(j) + 0.125*shp(4,i,l)*xl(j,i)
                end do ! i
              end do ! j
 
c             Move stresses and jacobian for printing
 
              xipa = xipa + 0.125d0*xipr
              wena = wena + 0.125d0*wengy
              do i = 1,6
                sigv(i) = sigv(i) + 0.125d0*sigp(i,l)
              end do ! i
 
c             Store arrays for plotting.
 
              sigp(10,l) = 0.0d0
              sigp(9,l)  = 0.0d0
 
            end do ! l
 
c           OUTPUT STRESSES
 
            if (isw .eq. 4) then
 
              call pstr3d(sigv,sigv(7))
 
              mct = mct - 2
              if(mct.le.0) then
                write(iow,2001) o,head
                if(ior.lt.0) write(*,2001) o,head
                mct = 50
              endif
 
              write(iow,2002) n,(sigv(ii),ii=1,6),
     &                       ma,(sigv(ii),ii=7,9),xx
              if(ior.lt.0) then
                write(*,2002) n,(sigv(ii),ii=1,6),
     &                       ma,(sigv(ii),ii=7,9),xx
              end if
 
c           PROJECT STRESSES ONTO THE NODES FOR PLOTTING
            elseif(isw.eq.8) then
 
c             Compute current geometry
 
              do i = 1,ndm
                do j = 1,nel
                  xu(i,j) = xl(i,j) + ul(i,j,1)
                end do ! j
              end do ! i
 
               do l = 1,lint
               call slcnxd(sigp(1,l),shp(1,1,l),xsj, p,s)
               enddo
 
            endif ! isw.eq.4
 
          endif  ! isw.eq.3.or.isw.eq.6
 
        endif ! isw.eq.13
    
      endif ! isw.eq.1
 
c     FORMAT 
2000  format(
     & /5x,'T h r e e   D i m e n s i o n a l   S o l i d',
     &     '   E l e m e n t'/)
2001  format(a1,20a4//5x,'Element Stresses'//
     &       '   Elem.   11-Stress   22-Stress   33-Stress   12-Stress',
     &   '   23-Stress   13-Stress'/
     &       '   Matl.    1-Stress    2-Stress    3-Stress',
     &   '     1-Coord     2-Coord     3-Coord ')
 
2002  format(i8,1p,6e12.4/i8,1p,6e12.4/1x)
      end
