c$Id: umati1.f,v 1.1 2004/01/11 19:11:33 rlt Exp $
      subroutine umati02(type,vv, d, ud, n1,n3)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2004: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose: Dummy user material model routine

c      Inputs:
c         type   - Name of material model
c         vv(5)  - Command line real data
c         d(*)   - Program material parameter data

c      Outputs:
c         ud(*)  - Material parameter data for model
c         n1     - Number of history items/point (time   dependent)
c         n3     - Number of history items/point (time independent)
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none

      include 'iofile.h'
      logical   pcomp, pinput, errck
      character type*15
      integer   n1,n3, ii
      real*8    vv(5),d(*),ud(*)

c     Set command name
      if(pcomp(type,'mat18',4)) then ! Default form: DO NOT CHANGE
         type = 'EMECvmdmuae2'         ! Specify new 'name'
c     Input user data and save in ud(*) array
      else          ! Perform input for user data
         n1 = 7     ! time dependent history variable    (1-Electrophysiology 2-Calcium con. 3- Active stretch 4-5-6-Passive response) 
         n3 = 11    ! time in-dependent history variable (fiber-sheet-normal directions - exciation time - segment number)
         errck = pinput(ud(1) ,9)
         errck = pinput(ud(10),6)
         errck = pinput(ud(16),9)
         errck = pinput(ud(25),9)
         write(  *,2000) n1
         write(iow,2000) n1
         write(  *,2001) (ud(ii), ii=1,9) 
         write(iow,2001) (ud(ii), ii=1,9) 
         write(  *,2002) (ud(ii), ii=10,15)
         write(iow,2002) (ud(ii), ii=10,15)
         write(  *,2003) (ud(ii), ii=16,24)
         write(iow,2003) (ud(ii), ii=16,24)
         write(  *,2004) (ud(ii), ii=25,33)
         write(iow,2004) (ud(ii), ii=25,33)
        
      endif
 2000 format(
     * 10x,'MATERIAL MODEL FOR FEAP ------------- (c) S. Goktepe, METU'/
     * 10x,'[  ] [     ] Phenom. Electromech. Monodomain AP Model.....'/
     * 10x,'[  ] [     ] (c) Baris Cansiz ............................'/
     * 10x,'[  ] [     ] UMAT18.......................................'/
     * 10x,'[  ] [     ] Viscoelastic Q1 monodomain model.............'/
     * 10x,'[  ] [     ] Multiplicative decomp..............24/12/2013'/
     * 10x,'[  ] [     ] New active stretch formulation.....19/07/2014'/
     * 10x,'[  ] [     ] Reformulation of multip. decomp....26/08/2014'/
     * 10x,'[  ] [n1   ] material history variables ...............',i3)
 2001 format(
     * 10x,'[ 1] [kappa]  p elas.: Bulk modulus (Penalty) ......',e12.5/
     * 10x,'[ 2] [    a]  p elas.: Isotropic shear modulus .....',e12.5/
     * 10x,'[ 3] [    b]  p elas.: Isotropic exponential term ..',e12.5/
     * 10x,'[ 4] [   af]  p elas.: Fiber direction modulus  ....',e12.5/
     * 10x,'[ 5] [   bf]  p elas.: Fiber direction exponent ....',e12.5/
     * 10x,'[ 6] [   an]  p elas.: Sheet direction modulus  ....',e12.5/
     * 10x,'[ 7] [   bn]  p elas.: Sheet direction exponent ....',e12.5/
     * 10x,'[ 8] [  afs]  p elas.: FS shear modulus ............',e12.5/
     * 10x,'[ 9] [  bfs]  p elas.: FS shear component ..........',e12.5)
 2002 format(
     * 10x,'[10] [  muf]  p visc.: Shear modulus in f  .........',e12.5/
     * 10x,'[11] [  mus]  p visc.: Shear modulus in s  .........',e12.5/
     * 10x,'[12] [  mun]  p visc.: Shear modulus in n  .........',e12.5/
     * 10x,'[13] [ etaf]  p visc.: Damping para. in f  .........',e12.5/
     * 10x,'[14] [ etas]  p visc.: Damping para. in s  .........',e12.5/
     * 10x,'[15] [ etan]  p visc.: Damping para. in n  .........',e12.5)
 2003 format(
     * 10x,'[16] [alpha]  elech. : alpha parameter .............',e12.5/
     * 10x,'[17] [gamma]  elech. : gamma parameter .............',e12.5/
     * 10x,'[18] [    b]  elech. : b parameter .................',e12.5/
     * 10x,'[19] [    c]  elech. : c parameter .................',e12.5/
     * 10x,'[20] [  mu1]  elech. : mu1 parameter ...............',e12.5/
     * 10x,'[21] [  mu2]  elech. : mu2 parameter ...............',e12.5/
     * 10x,'[22] [ diso]  elech. : isotropic conduc. ...........',e12.5/
     * 10x,'[23] [ dort]  elech. : anisotro. conduc. ...........',e12.5/
     * 10x,'[24] [ gs2 ]  me fed.: max conductance lambdot .....',e12.5)
 2004  format(
     * 10x,'[25] [ xeta]  active : Active stress coef...........',e12.5/
     * 10x,'[26] [  xk1]  active : Calcium conct coef...........',e12.5/
     * 10x,'[27] [   xm]  active : Calcium conct (power term)...',e12.5/
     * 10x,'[28] [   xq]  active : Calcium conct coef...........',e12.5/
     * 10x,'[29] [  xk2]  active : Active stretch coef..........',e12.5/
     * 10x,'[30] [xbeta]  active : Active stretch coef..........',e12.5/
     * 10x,'[31] [   xp]  active : Active stretch coef..........',e12.5/
     * 10x,'[32] [ gs1 ]  me fed.: maximum conductance .........',e12.5/
     * 10x,'[33] [ phis]  me fed.: reversal potential  .........',e12.5)
 
c
      return 
      end

c$Id: umatl1.f,v 1.2 2004/02/25 21:56:20 rlt Exp $
      subroutine umatl02(f,detf,phi,d,ud,hn,h1,h0,nh,ii,istrt,sig,dd,
     *                                                              isw)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2004: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose: User Constitutive Model 1

c     Input:
c          f(*)      -  Current strains at point      (small deformation)
c                    -  Deformation gradient at point (finite deformation)
c          detf      -  Trace of strain at point
c                    -  Determinant of deformation gradient
c          phi       -  Action potential
c          d(*)      -  Program material parameters (ndd)
c          ud(*)     -  User material parameters (nud)
c          hn(nh)    -  History terms at point: t_n
c          h1(nh)    -  History terms at point: t_n+1
c          h0(nh)    -  Time independent history variables : fiber directions at undeformed configuration
c          nh        -  Number of history terms
c          ii        -  Current point number
c          l         -  Current Gauss Point number
c          isw       -  Solution option from element
c          sig(1--3) -  Volumetric Kirchhoff stresses coming from the element routine

c     Output:
c          sig(*)    -  Stresses at point.
c                       N.B. 1-d models use only sig(1)
c          dd(6,*)   -  Current material tangent moduli
c                       N.B. 1-d models use only dd(1,1) and dd(2,1)
c-----[--.----+----.----+----.-----------------------------------------]
      implicit none

      include 'tdata.h'
      include 'counts.h'
      include 'pointer.h'
      include 'cdata.h'
      include 'comblk.h'
      include 'elcoor.h'        ! xref(3), xcur(3)
      include 'eldata.h'        ! dm,n,ma,mct,mct,iel,nel
c..
!      include   'segments.h'
      integer nh,istrt, isw, ii
      real*8  phi
      real*8  f(3,*),detf,d(*),ud(*),hn(nh),h1(nh), sig(*),dd(6,6,*)
      real*8  h0(*)
c...  DEFINE LOCAL VARIABLES
      integer i, j, l, k, iin(6), jin(6), ij(3,3), nitl
      real*8  xrdot,xtol,res, dresdr, dresdphi, drdphi
c...  material parameters
      real*8  kappa, a, b, af, bf, as, bs, afs, bfs              ! passive response - elastic
      real*8  xmuf, xmus, xmun, xetaf, xetas, xetan              ! passive response - viscous
      real*8  alpha, gamma, xb, xc, xmu1, xmu2, diso, dort, xpot ! electrophysiology
      real*8  xeta, xk1,xq, xk2, xbeta, xp                       ! active response
      integer xm                                                 ! active response
      real*8  gs1,gs2, phis                                      ! mechanoelectric feedback
c...  passive response
      real*8  xi(6), xii(6,6), aa(6,6), bb(6), dbb(6) 
      real*8  xf(3), xs(3), xn(3), xfe(3), xse(3), xne(3), ff(6), nn(6)
      real*8  xfem(3), xsem(3), xnem(3), ffm(6), ssm(6), nnm(6)
      real*8  fft(6), ss(6), fs(6), dffm(6), dssm(6), dnnm(6)
      real*8  dxfe(3), dxse(3), dxne(3), xft(3)
      real*8  xi1, xi4f, xi4s, xi4n, xi8fs, lamb,lamb_cr,xxfm1
      real*8  xxfm2, lamb_n, lamb_rate
      real*8  xi4fm, xi4sm, xi4nm, lambf,lambs,lambn
      real*8  dxi4fm, dxi4sm, dxi4nm
c...  isochoric split
      real*8 fb(3,3), sig_iso(6), aa_iso(6,6)
      real*8 xip(6,6), xmm(6), trace, sigb(6), aab(6,6), fact
c
      real*8  psi1,  psi4f, psi4s, psi4n,  psi8fs
      real*8  dpsi1, dpsi4f, dpsi4s, dpsi4n, dpsi8fs
      real*8  sigv, dsigv
      real*8  dot2_sg, xnorm
c...  viscous part
      real*8 epsf, epss, epsn, epsvf, epsvs, epsvn, sigf, sigs, sign
      real*8 psiv4f, psiv4s, psiv4n, dpsiv4f, dpsiv4s, dpsiv4n
      real*8 xkf, xks, xkn, xcf, xcs, xcn, daf,das,dan
c...  electrical part
      real*8 xrn, xr,gphi(3), phitt
      real*8 fphi, fphip, xfm, xfn, xfmm, abb1, xpot2 ! abb = abbreviation
c...  active response    
      real*8 Fm(3,3), xi4fe, xffe(3), ffe(6), lamba, lamban
      real*8 dFm(3,3), Fa(3,3),invFa(3,3), dJa, Ja, dxffe(3), dffe(6) 
      real*8 dxi4fe,xxf, xxf0, xxc, xxcb, xxcn, gx, fx
      real*8 hd(6), xh(3), dtaubdphi(6)
c...  projections
      real*8 xfl, xsl, xnl, xxfn(3), xxsn(3), xxnn(3)
      real*8 sigff, sigss, signn,sss(6),sigp(6),sigpff
      real*8 epsff, epsss, epsnn
c...  abbreviations
      real*8 invla,  invdetf  
      real*8 abb2,abb3,abb4,abb5,abb6,abb7     
c...
!      real*8 xcur(3),rad,cthe,cthe,the 
c
      integer lint, lg, ll
      integer n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,n11,n12,n13,n14,n15,n16
      real*8 seg,xcof
      logical setvar, palloc, flag 
      double precision xpoint,xlen,xpre,tact
c
c...  define Voigt maps 
      data iin/1,2,3,1,2,1/, jin/1,2,3,2,3,3/
      data ij/ 1 , 4 , 6 ,
     *         4 , 2 , 5 ,
     *         6 , 5 , 3 /
c...  define identity tensors 
      data  xi/1.d0,1.d0,1.d0,0.d0,0.d0,0.d0/
      data xii/1.d0, 0.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     &         0.d0, 1.d0, 0.d0, 0.d0, 0.d0, 0.d0,
     &         0.d0, 0.d0, 1.d0, 0.d0, 0.d0, 0.d0,
     &         0.d0, 0.d0, 0.d0, 5.d-1,0.d0, 0.d0,
     &         0.d0, 0.d0, 0.d0, 0.d0, 5.d-1,0.d0,
     &         0.d0, 0.d0, 0.d0, 0.d0, 0.d0, 5.d-1/
c...  Vector to use in matrix summations when Voigt notation is used
      data xmm / 1.d0 , 1.d0 , 1.d0 , 2.d0 , 2.d0 , 2.d0 /
c
c...  physical DIMENSION factors
c     Phi[mV]=fp*phi[-] - dp, dt[ms] = ft* dt[-]
      real*8 fp,dp,ft,dtau,phit
      fp  = 100.d0 
      dp  = 80.d0 
      ft  = 12.9d0
c...  1/detf
      invdetf = 1.d0/detf
c...  Initialize history variables ! bc
      if(isw.eq.14) then
      hn(1) = 0.d0 ! 4.144E-002
      hn(2) = 0.d0 ! initial value for calcium concentration
      hn(3) = 1.d0 ! initial value for active stertch
      hn(4) = 0.d0
      hn(5) = 0.d0
      hn(6) = 0.d0
      hn(7) = 1.d0

      h1(1) = 0.d0 ! 4.144E-002  ! 0.d0
      h1(2) = 0.d0
      h1(3) = 0.d0
      h1(4) = 0.d0
      h1(5) = 0.d0
      h1(6) = 0.d0
      h1(7) = 0.d0
      
      h0(10) = 0.d0
      h0(11) = 1.d0  ! lamb_cr
      endif   ! isw 14   
c  
c...  Allocate an array for myofiber directions and excitation time
c     ---------------------------- STORAGE -------------------------
      lg = istrt                ! current Gauss point (from element)
c..  get the myocyte directions from memory  
      do i = 1,3
      xf(i) = h0(i)
      xs(i) = h0(i+3)
      xn(i) = h0(i+6)
      enddo   
!xc...  set the excitation time 
!      if (phi.gt.-50.d0.and.h0(10).lt.dt.and.ttim.ge.4405.d0) then 
!      h0(10) = ttim  - 4405.d0     
!      endif
!      tact = h0(10)
!xc...  scale the APD inversely prop. to tact for ECG
!      ft = ft *  (1.d0 - 0.7d0*tact/100.d0) 
!      if(ft.lt.0.01d0) write(*,*) 'ft is strange', ft

!      write(*,*) h0(11)
c..   CONVERSION to NON-DIMENSIONAL VALUES
      phit = (phi + dp)/fp
      dtau =  dt/ft    
c...  Get the material parameters from ud-field
c..   Elastic passive response
      kappa = ud(1)            
      a     = ud(2)              
      b     = ud(3)              
      af    = ud(4)              
      bf    = ud(5)             
      as    = ud(6)             
      bs    = ud(7)
      afs   = ud(8)
      bfs   = ud(9)
c..   Viscous passive response
      xmuf  = ud(10)              
      xmus  = ud(11)             
      xmun  = ud(12)             
      xetaf = ud(13)
      xetas = ud(14)
      xetan = ud(15)     
c..   Electrophysiology 
      alpha  = ud(16)            
      gamma  = ud(17)            
      xb     = ud(18)            
      xc     = ud(19)            
      xmu1   = ud(20)            
      xmu2   = ud(21)            
      diso   = ud(22)            
      dort   = ud(23)            
      gs2    = ud(24)
c..   Coupled part 
      xeta   = ud(25)           
      xk1    = ud(26)           
      xm     = ud(27)           
      xq     = ud(28)           
      xk2    = ud(29)           
      xbeta  = ud(30)
      xp     = ud(31)  
c
      gs1    = ud(32)           ! MEF
      phis   = ud(33)           ! MEF
c



      if (ttim.ge.200.d0.and.ttim.le.210.d0) then
         xpot = .5d0
      else         
         xpot = 0.d0
      endif
      
      
C...  Get the history variables ast t=t_n
      xrn   = hn(1)
      xxcn  = hn(2) 
      lamban= hn(3)
!      if(ttim.le.5100)   xxcn = 0.d0
!      if(ttim.le.5100) lamban = 1.d0

C     ---- KINEMATICS ---- 
c...  Compute active stretch 
      phitt = phit !
      if(phit.ge.1.d0) phitt = 0.9999d0
      if(phit.lt.0.d0) phitt = 0.d0
c...  Compute calcium concentration
      gx  = -xq*dlog(1.d0 - phitt)**3
      xxc = (gx*dt + xxcn)/(1.d0 + dt*xk1)
!      xxc = 0.d0
c...  Update history
      h1(2) = xxc
c...  Active stretch
      fx    = xbeta*(dexp(-xp*xxc) - 1.d0)
      lamba = ( (fx + xk2)*dt + lamban )/(1.d0 + dt*xk2)
!      lamba = 1.d0
c...  Update history
      h1(3) = lamba
c.....Abbreviation
      invla = 1.d0/lamba
c...  Compute mechanical deformation gradient
      abb2  = (invla - 1.d0)
      Fm = 0.d0
      do i = 1,3
      do j = 1,3
      do k = 1,3 
      Fm(i,j) = Fm(i,j) + abb2*f(i,k)*xf(k)*xf(j)
      enddo ! k - summation
      Fm(i,j) = Fm(i,j) + f(i,j)
      enddo ! j
      enddo ! i 
c...  Compute the derivative of mechanical deformation gradient w.r.t. phi 
      abb5 = xp*xbeta*dexp(-xp*xxc)*3.d0*xq*dlog(1.d0-phitt)**2*
     *       dt*dt/lamba/lamba/(1.d0+dt*xk1)/(1+dt*xk2)/(1-phitt)

c...  Compute Left Cauchy-Green deformation tensor
      bb(1) = f(1,1)*f(1,1) + f(1,2)*f(1,2) + f(1,3)*f(1,3)
      bb(2) = f(2,1)*f(2,1) + f(2,2)*f(2,2) + f(2,3)*f(2,3)
      bb(3) = f(3,1)*f(3,1) + f(3,2)*f(3,2) + f(3,3)*f(3,3)
      bb(4) = f(1,1)*f(2,1) + f(1,2)*f(2,2) + f(1,3)*f(2,3)
      bb(5) = f(2,1)*f(3,1) + f(2,2)*f(3,2) + f(2,3)*f(3,3)
      bb(6) = f(1,1)*f(3,1) + f(1,2)*f(3,2) + f(1,3)*f(3,3)
c
c...  the deformed preferred directions ---> computed from F 
      do i=1,3
      xfe(i) = f(i,1)*xf(1) + f(i,2)*xf(2) + f(i,3)*xf(3)
      xse(i) = f(i,1)*xs(1) + f(i,2)*xs(2) + f(i,3)*xs(3)
      xne(i) = f(i,1)*xn(1) + f(i,2)*xn(2) + f(i,3)*xn(3)
      enddo
c

c...  deformed structural tensors ---> computed from f 
      do i=1,6
      ff(i)  =  xfe(iin(i))*xfe(jin(i))
      ss(i)  =  xse(iin(i))*xse(jin(i))
      nn(i)  =  xne(iin(i))*xne(jin(i))
      fs(i)  = (xfe(iin(i))*xse(jin(i))+xfe(jin(i))*xse(iin(i)))/2.d0
      enddo
c
c...  Compute the stretches 
      lambf = dot2_sg(6,xi,ff)**0.5d0 
      lambs = dot2_sg(6,xi,ss)**0.5d0 
      lambn = dot2_sg(6,xi,nn)**0.5d0 
c...  Compute the invariants 
      xi1   = bb(1) + bb(2) + bb(3)
      xi4f  = dot2_sg(6,xi,ff) 
      xi4s  = dot2_sg(6,xi,ss) 
      xi4n  = dot2_sg(6,xi,nn)
      xi8fs = dot2_sg(6,xi,fs) 
!c...  Compute the mechanical invariants
!      xi4fm  = dot2_sg(6,xi,ffm) 
!      xi4sm  = dot2_sg(6,xi,ssm) 
!      xi4nm  = dot2_sg(6,xi,nnm)   

!      open(12,file='debug')


cl... previous lamb
      lamb_n = hn(7)
c...  compute the stretch in the myocyte direction 
      lamb =  dsqrt(xi4f) !dsqrt(xfe(1)**2.d0 + xfe(2)**2.d0 + xfe(3)**2.d0)
      h1(7) = lamb
      lamb_rate = (lamb-lamb_n)/dt

!      write(*,*) gs1,gs2
!      if(ttim.eq.27100.d0) h0(11) =lamb ! back1          11998 12000.d0
      lamb_cr = 1.d0!h0(11)
!      write(*,*) h0(11)
c...  save lamb to time dependent history variable 7th      

      gs2 = 0.d0
cl... lambf_rate      
      
c...  Impose tension only condition 
      xxfm1 = 1.d0
      xxfm2 = 1.d0
      xfm  = 1.d0 
      xfn  = 1.d0 
      if (lamb.lt.lamb_cr) xxfm1  = 0.d0
      if (lamb_rate.lt.0)  xxfm2  = 0.d0
      if (xi4f.lt.1.d0) xfm  = 0.d0 
      if (xi4s.lt.1.d0) xfn  = 0.d0
c
!      if(n.eq.1)write(*,*) xi1
c------------------------------------------------------------------
c------------------------------------------------------------------
c--------------------  Projections --------------------------------
c------------------------------------------------------------------
c------------------------------------------------------------------
      if (isw.eq.8) then ! isw8
C     ---- PURELY MECHANICAL PART ----
c-----------------
c... ELASTIC PART
c-----------------
c... Derivatives of the free energy wrt invariants 
      psi1   = a*dexp(b*(xi1-3.d0))/2.d0 
      psi4f  = af*(xi4f-1.d0)*dexp(bf*(xi4f-1.d0)**2.d0)
      psi4s  = as*(xi4s-1.d0)*dexp(bs*(xi4s-1.d0)**2.d0)
      psi8fs = afs*xi8fs*dexp(bfs*xi8fs*xi8fs)
c
c--------------------
c--- VISCOUS PART ---
c--------------------
c...  Logarithmic strains
      epsf  = dlog(lambf)
      epss  = dlog(lambs)
      epsn  = dlog(lambn)
c... Logarithmic strains
!      epsf = dlog(dsqrt(xi4fm))
!      epss = dlog(dsqrt(xi4sm))
!      epsn = dlog(dsqrt(xi4nm))

c...  Update of the internal variables
      epsvf = ( hn(4) + dt*xmuf*epsf/xetaf )/( 1.d0 + dt*xmuf/xetaf )
      epsvs = ( hn(5) + dt*xmus*epss/xetas )/( 1.d0 + dt*xmus/xetas )
      epsvn = ( hn(6) + dt*xmun*epsn/xetan )/( 1.d0 + dt*xmun/xetan )
      h1(4) =   epsvf
      h1(5) =   epsvs
      h1(6) =   epsvn
c...  Derivatives of the viscous free energy wrt invariants 
      sigf = xmuf*(epsf - epsvf -  log(lamba))
      sigs = xmus*(epss - epsvs)
      sign = xmun*(epsn - epsvn)
c
      psiv4f = sigf/xi4f
      psiv4s = sigs/xi4s
      psiv4n = sign/xi4n
c
     
c
      sigv  = kappa*(1.d0-1.d0/detf)
c...  Kirchhoff stresses 
      do i = 1,6
      sig(i) =        detf*sigv*xi(i) 
     &        +  2.d0*     psi1*bb(i)
     &        +  2.d0*xfm* psi4f*ff(i) + psiv4f * ff(i)  ! elastic + viscous in f direction
     &        +  2.d0*xfn* psi4s*ss(i) + psiv4s * ss(i)  ! elastic + viscous in s direction
     &        +                          psiv4n * nn(i)  !           viscous in n direction
     &        +      2.d0* psi8fs*fs(i)
      sig(i) = sig(i) /detf
      enddo   ! i

c...  Kirchhoff passive stresses 
      do i = 1,6
      sigp(i) =        detf*sigv*xi(i) 
     &        +  2.d0*     psi1*bb(i)
     &        +  2.d0*xfm* psi4f*ff(i) !+ psiv4f * ffm(i)  ! elastic + viscous in f direction
     &        +  2.d0*xfn* psi4s*ss(i) !+ psiv4s * ssm(i)  ! elastic + viscous in s direction
     &       ! +                          psiv4n * nnm(i)  !           viscous in n direction
     &        +      2.d0* psi8fs*fs(i)
      sigp(i) = sigp(i)/detf
      enddo   ! i

c...  normalize preferred directions for stress and strain projections
      xfl = dsqrt( xfe(1)**2.d0 + xfe(2)**2.d0 + xfe(3)**2.d0 )
      xxfn(1) = xfe(1)/xfl
      xxfn(2) = xfe(2)/xfl
      xxfn(3) = xfe(3)/xfl 

c...  compute visco-active total true stresses in fiber direction
      sigff = 0.d0
      do i = 1,3
      do j = 1,3
      sigff = sigff + xxfn(i)*sig(ij(i,j))*xxfn(j)
      enddo
      enddo
c...  compute passive true stresses in fiber direction
      sigpff = 0.d0
      do i = 1,3
      do j = 1,3
      sigpff = sigpff + xxfn(i)*sigp(ij(i,j))*xxfn(j)
      enddo
      enddo
c


c...  assign the projections
c$$$      sig(1) =  lamb!xf(1)!lamb
c$$$      sig(2) =  lamb_rate !xxc   !xf(2)   !dsqrt(xfe(1)**2.d0 + xfe(2)**2.d0 + xfe(3)**2.d0)
c$$$      sig(3) =  xxfm1*gs1*(lamb-lamb_cr)*(phis-phit)   !dexp(epsvf) !dexp(epsvf)
c$$$      sig(4) = xxfm2*gs2*lamb_rate*(phis-phit)        !lamb/lamba/dexp(epsvf)
c$$$      sig(5) = xxfm1*gs1*(lamb-lamb_cr)*(phis-phit)   !dexp(epsvf) !dexp(epsvf)
c$$$     &       + xxfm2*gs2*lamb_rate*(phis-phit) !lamb/lamba/dexp(epsvf)

      sig(1) = lamb
      sig(2) = xxfm1*gs1*(lamb-lamb_cr)*(phis-phit)


      
      goto 102 ! exit without doing any extra computation
      endif ! isw.eq.8
c- end of proj
c

C     ---- PURELY ELECTRICAL PART ---- 
c...  get the spatial potential gradient of from sig(11-13) field
      gphi(1) = sig(11)
      gphi(2) = sig(12)
      gphi(3) = sig(13)
!xC     >> EXTERNAL STIMULATIONS <<
!     x!      call stimulate_heart(ttim,l, xpot)


!      call stimulate_plate(ttim,xpot)
      



c...  COMPUTATION OF THE ELECTRICAL BODY FORCE and ITS DERIVATIVE
c...  --------------- B O X ------------
c...  -START- local Newton iteration for 'r' 
      nitl = 0
      xtol = 1.d-12
      xr   = xrn 
c
      xrdot = ( gamma + xmu1*xr/(xmu2+phit) )
     &      * (-xr - xc*phit*(phit-xb-1.d0) )
      res = xr -xrn - dtau*xrdot
 101  continue      
      nitl = nitl + 1      
c...  Compute residuum and tangent
      xrdot = ( gamma + xmu1*xr/(xmu2+phit) )
     &      * (-xr - xc*phit*(phit-xb-1.d0) )
      res = xr -xrn - dtau*xrdot
      dresdr = 1.d0 + dtau *( 
     &  xmu1*(2.d0*xr + xc*phit*(phit-xb-1.d0))/(xmu2+phit) + gamma)       
c...  Newton update 
      xr = xr - res / dresdr
c...  check the convergence
      if ((nitl.lt.50).and.(dabs(res).gt.xtol)) go to 101
      if  (nitl.eq.50) write(*,*)'>No Convergence! |res|=',dabs(res)
!      if(n.eq.1) write(*,*) nitl
c...  -END- local Newton iteration for 'r'
c...  --------------- B O X ------------
c...  Update history, compute sensitivities and F(phit) 
      h1(1) = xr
      dresdphi = dtau *(
     &     -xmu1*xr* (xr+xc*phit*(phit-xb-1.d0))/(xmu2+phit)/(xmu2+phit) 
     &     + (gamma+xmu1*xr/(xmu2+phit))*xc*(2.d0*phit-xb-1.d0) )
      drdphi   = - dresdphi / dresdr 
c
      fphi = - xc*phit*(phit-alpha)*(phit-1.d0) -xr*phit + xpot 
     &     + xxfm1*gs1*(lamb-lamb_cr)*(phis-phit)
     &     + xxfm2*gs2*lamb_rate*(phis-phit) 
      
      fphip= - xc*(3.d0*phit*phit-2.d0*(alpha+1.d0)*phit+alpha) - xr
     &  - phit*drdphi - xxfm1*gs1*(lamb-lamb_cr)
     &                - xxfm2*gs2*lamb_rate



      
c...  CORRECT DIMENSIONS
      fphi  = fp*fphi/ft
      fphip = fphip  /ft 



c...  pass fphi and fphip through dd-field
      dd(1,3,2) = fphi 
      dd(2,3,2) = fphip 
c...  store the MEF tangent 2*dphidg with dimensional corrections
      abb1 = fp*xxfm1*gs1*(phis-phit)/lamb/ft
      dd(1,4,2) = ff(1)*abb1
      dd(2,4,2) = ff(2)*abb1
      dd(3,4,2) = ff(3)*abb1
      dd(4,4,2) = ff(4)*abb1
      dd(5,4,2) = ff(5)*abb1
      dd(6,4,2) = ff(6)*abb1
C
ccc
C     ---- PURELY MECHANICAL PART ----
c--------------------
c--- ELASTIC PART ---
c--------------------
c...  Derivatives of the elastic free energy wrt invariants 
      psi1    = a*dexp(b*(xi1-3.d0))/2.d0 
      psi4f   = af*(xi4f-1.d0)*dexp(bf*(xi4f-1.d0)**2.d0)
      psi4s   = as*(xi4s-1.d0)*dexp(bs*(xi4s-1.d0)**2.d0)
      psi8fs  = afs*xi8fs*dexp(bfs*xi8fs*xi8fs)
c
      dpsi1   = b*psi1
      dpsi4f  = af*(1.d0+2.d0*bf*(xi4f-1.d0)**2.d0)
     &        * dexp(bf*(xi4f-1.d0)**2.d0)
      dpsi4s  = as*(1.d0+2.d0*bs*(xi4s-1.d0)**2.d0)
     &        * dexp(bs*(xi4s-1.d0)**2.d0)
      dpsi8fs = afs*(1.d0+2.d0*bfs*xi8fs**2.d0)
     &        * dexp(bfs*xi8fs**2.d0) 
c
c--------------------
c--- VISCOUS PART ---
c--------------------
c...  Logarithmic strains
      epsf  = dlog(lambf)
      epss  = dlog(lambs)
      epsn  = dlog(lambn)
c... Logarithmic strains
!      epsf = dlog(dsqrt(xi4fm))
!      epss = dlog(dsqrt(xi4sm))
!      epsn = dlog(dsqrt(xi4nm))

c...  Update of the internal variables
      epsvf = ( hn(4) + dt*xmuf*(epsf-dlog(lamba))/xetaf )/
     *                   ( 1.d0 + dt*xmuf/xetaf )
      epsvs = ( hn(5) + dt*xmus*epss/xetas )/( 1.d0 + dt*xmus/xetas )
      epsvn = ( hn(6) + dt*xmun*epsn/xetan )/( 1.d0 + dt*xmun/xetan )
      h1(4) =   epsvf
      h1(5) =   epsvs
      h1(6) =   epsvn
c...  Derivatives of the viscous free energy wrt invariants 
      sigf = xmuf*(epsf - epsvf -  dlog(lamba))
      sigs = xmus*(epss - epsvs)
      sign = xmun*(epsn - epsvn)
c
      psiv4f = sigf/xi4f
      psiv4s = sigs/xi4s
      psiv4n = sign/xi4n
c
      xkf = 1.d0 + dt*xmuf/xetaf
      xks = 1.d0 + dt*xmus/xetas
      xkn = 1.d0 + dt*xmun/xetan
c
      xcf = xmuf/xkf
      xcs = xmus/xks
      xcn = xmun/xkn
c 
      dpsiv4f = (xcf - 2.d0*sigf)/xi4f/xi4f
      dpsiv4s = (xcs - 2.d0*sigs)/xi4s/xi4s
      dpsiv4n = (xcn - 2.d0*sign)/xi4n/xi4n
     
c
      sigv  = kappa*(1.d0-1.d0/detf)
      dsigv = kappa/detf/detf
c...  Kirchhoff stresses 
      do i = 1,6
      sig(i) =        detf*sigv*xi(i) 
     &        +  2.d0*     psi1*bb(i)
     &        +  2.d0*xfm* psi4f*ff(i) + psiv4f * ff(i)  ! elastic + viscous in f direction
     &        +  2.d0*xfn* psi4s*ss(i) + psiv4s * ss(i)  ! elastic + viscous in s direction
     &        +                          psiv4n * nn(i)  !           viscous in n direction
     &        +      2.d0* psi8fs*fs(i)
      sig(i) =  sig(i) /detf
      enddo   ! i
c
c...  Mechanical Moduli
      do i = 1,6
      do j = 1,6
      aa(i,j)  =  detf*(sigv + detf*dsigv)*xi(i)*xi(j)
     &         -  2.d0*detf*sigv*xii(i,j)
     &         +  4.d0*      dpsi1*bb(i)*bb(j)
     &         +  4.d0*xfm* dpsi4f*ff(i)*ff(j) + dpsiv4f * ff(i)*ff(j)  ! elastic + viscous in f direction
     &         +  4.d0*xfn* dpsi4s*ss(i)*ss(j) + dpsiv4s * ss(i)*ss(j)  ! elastic + viscous in s direction
     &         +                                 dpsiv4n * nn(i)*nn(j)  !           viscous in n direction
     &         +      4.d0* dpsi8fs*fs(i)*fs(j) 
      dd(i,j,1) =  aa(i,j)/detf 
      enddo    ! j
      enddo    ! i
!xc  
!x
!x
!xc
!xC     ---- COUPLED ELECTRO-MECHANICAL PART ----     
!xc...  Compute the mixed second-order moduli dtaubdphi  
!xc...  Compute the derivative of mechanical deformation gradient w.r.t. phi 
!x      abb6 = -xp*xbeta*dexp(-xp*xxc)*3.d0*xq*dlog(1.d0-phitt)**2*
!x     *       dt*dt/(1.d0+dt*xk1)/(1+dt*xk2)/(1-phitt)/fp
!x      do i=1,6 
!x      dtaubdphi(i) = -xmuf/xi4f*invla*abb6*ff(i)      
!x      enddo ! i



c
      dd(1,1,2) =dtaubdphi(1)   
      dd(2,1,2) =dtaubdphi(2)   
      dd(3,1,2) =dtaubdphi(3)   
      dd(4,1,2) =dtaubdphi(4)    
      dd(5,1,2) =dtaubdphi(5)    
      dd(6,1,2) =dtaubdphi(6)     

 
      do i=1,6
      hd(i) = diso*xi(i)  + dort*ff(i)
!      hd(i)  =dort*xi(i) + (diso-dort)*ff(i)
      dd(i,2,2) = hd(i)  
      enddo ! i
c
c...  Compute the electrical flux, storage: sig(11-13) 
      xh(1) = hd(1)*gphi(1) + hd(4)*gphi(2) + hd(6)*gphi(3)
      xh(2) = hd(4)*gphi(1) + hd(2)*gphi(2) + hd(5)*gphi(3)
      xh(3) = hd(6)*gphi(1) + hd(5)*gphi(2) + hd(3)*gphi(3)
      sig(11) = xh(1)
      sig(12) = xh(2)
      sig(13) = xh(3)
c
c...  Compute the mixed third order moduli 2dhdg
c     -diso*(gphi _b*del_ac + gphi_c*del_ab)
      do i =1,3
      do j =1,6            
      dd(i,j,3) = -diso*( gphi(iin(j))*xii(i,jin(j)) + 
     &        gphi(jin(j))*xii(i,iin(j)) )
      enddo                     !j
      enddo                     !i



102   continue
      end
