c-----------------------------------------------------------------------
      subroutine slcnxd(sig,shp,xsj,p,s)
c-----------------------------------------------------------------------
c     Modification log                                Date (dd/mm/year)
c       Original version                                    01/11/2012
c-----------------------------------------------------------------------
c      Purpose: 2D/3D projection of element variables to nodes
c
c      Inputs:
c        sig(iste,*)   - Stresses at quadrature points
c        shp(3,iste,*) - Shape functions at quadrature points
c        xsj(*)        - Volume element at quadrature points
c
c      Outputs:
c        p(nen)   - Weights for 'lumped' projection
c        s(nen,*) - Integral of variables
c-----------------------------------------------------------------------
      implicit  none
      include  'cdata.h'     ! nen
      include  'eldata.h'    ! nel
      include  'sdata.h'     ! ndm
      include  'strnum.h'    ! iste
      integer   i,j,dum
      real*8    p(*),s(nen,*),xsj,sig(iste),shp((ndm+1),nen)
      save




c.... row sum lumped projection routine
      do i = 1,nel
      p(i) = p(i) + shp((ndm+1),i)*xsj
c.... stress projections 1-6 ---> solid element, 14-20-----> surface element
        do j = 1,iste
        s(i,j) = s(i,j) + sig(j)*shp((ndm+1),i)*xsj
        enddo
      enddo      
      iste = 20         
      end
